package com.c503.ca.cadv.common.config;


import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;

import java.util.concurrent.ThreadPoolExecutor;

/**
 * 线程池
 */
@Slf4j
public class ExecutorConfig {

    public ThreadPoolTaskExecutor nodeAsyncServiceExcutor(String name, int poolSize) {
        ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();
        executor.setCorePoolSize(poolSize);
        executor.setMaxPoolSize(poolSize);
        executor.setQueueCapacity(9999);
        executor.setThreadNamePrefix(name + "-");
        executor.setBeanName(name);
        executor.setRejectedExecutionHandler(
                new ThreadPoolExecutor.CallerRunsPolicy()
        );
        executor.setWaitForTasksToCompleteOnShutdown(true);
        executor.initialize();
        log.info("init threadPool nodeAsyncServiceExecutor" + "_" + name + "_" + poolSize);
        return executor;
    }
}
