package com.c503.ca.cadv.common.constant;

import com.c503.ca.cadv.common.util.domain.CacheConstants;

/**
 * 权限相关常量
 *
 * @author liaow
 */
public class SecurityConstants {

    public static final String ADMIN_ID = "1";
    public static final String ADMIN_LOGIN_ID = "admin";
    public static final String DEFAULT_PASSWORD = "111111";

    /**
     * 令牌有效期(秒)
     */
    public final static long EXPIRE_TIME = 60 * 30 * 6;
    public static final String LOGIN_TOKEN = CacheConstants.sysCommon + "tokens:";
    /**
     * 令牌自定义标识
     */
    public static final String HEADER = "Authorization";
    public static final String HEADER_USER_ID = "user_id";
    public static final String HEADER_USER_NAME = "username";

    /**
     * Header TGC
     */
    public static final String HEADER_TGC = "TGC";

    /**
     * 防重提交 redis key
     */
    public static final String REPEAT_SUBMIT_KEY = "repeat_submit:";
    /**
     * 令牌前缀
     */
    public static final String TOKEN_PREFIX = "Bearer ";

    public static String[] AUTHORIZE_PERMIT_ALL = {"/cadv/login", "/cadv/logout", "/cadv/register/**", "/cadv/ws/**", "/cadv/actuator/**", "/cadv/management/**",
            "/cadv/profile-info", "/cadv/attachment/img/**", "/cadv/modeler/**", "/cadv/attachment/download/**", "/cadv/v2/api-docs/**", "/cadv/swagger-ui/**",
            "/cadv/swagger-resources/**", "/cadv/ge/enum/**", "/cadv/dict/**", "/cadv/sys/getDate","/cadv/sys/getTimeMillis", "/cadv/fo/append-file/getHelpFile",
            "/cadv/admin/**",""
    };

    public static String[] AUTHORIZE_PERMIT_MONITOR = {"/cadv/wallboard", "/cadv/assets/**", "/cadv/sba-settings.js",
            "/cadv/applications", "/cadv/instances/**",
    };

    /**
     * 要求前端路由前缀统一添加 /f/
     */
    public static String[] STATIC_RESOURCES = {"/index.html", "/favicon.ico", "/f/**", "/static/**",
            "*.exe", "*.js", "*.css", "*.html", "*.json", "*.woff2", "*.woff", "*.ttf", "*.png", "*.jpg", "**.ico"};

}
