package com.c503.ca.cadv.common.transfer;

import lombok.Getter;
import lombok.Setter;

/**
 * 传输进度对象
 *
 * @author liaow
 */
@Setter
@Getter
public class TransferProgress {

    public static final int STATUS_PENDING = 0;
    public static final int STATUS_ING = 1;
    public static final int STATUS_OK = 2;
    public static final int STATUS_FAIL = 3;

    /**
     * 传输状态
     */
    private int status = STATUS_PENDING;
    /**
     * 总大小
     */
    private long size;
    /**
     * 已操作大小
     */
    private long operatedSize;

    private long lastOperatedSize;

    /**
     * 获取进度百分比
     */
    public float getPercentage() {
        if (size == 0) {
            return (float) operatedSize * 100 / 1;
        } else {
            return ((float) operatedSize / (float) size) * 100;
        }
    }

    /**
     * 与前一次操作数据量相减，获取操作速度
     */
    public long getSpeed() {
        if (lastOperatedSize == 0) {
            return 0;
        }
        return (operatedSize - lastOperatedSize);
    }

}
