package com.c503.ca.cadv.common.util;

import com.c503.ca.cadv.common.util.orika.OrikaBeanHelper;
import ma.glasnost.orika.MapperFacade;

import java.util.List;

/**
 * Bean 转换工具
 *
 * @author liaow
 */
@SuppressWarnings({"unused"})
public class BeanConvertUtils extends OrikaBeanHelper {

    /**
     * 对象间转换
     */
    public static MapperFacade getMapperFacade(boolean mapNulls) {
        return mapNulls ? getMapperFacade() : getMapperFacadeNoMapNulls();
    }

    /**
     * 对象间转换
     */
    public static <S, D> void map(S sourceObject, D destinationObject) {
        map(sourceObject, destinationObject, true);
    }

    /**
     * 对象间转换
     */
    public static <S, D> void map(S sourceObject, D destinationObject, boolean mapNulls) {
        getMapperFacade(mapNulls).map(sourceObject, destinationObject);
    }

    /**
     * 映射新的目标类型对象
     */
    public static <S, D> D map(S sourceObject, Class<D> destinationClass) {
        return map(sourceObject, destinationClass, true);
    }

    /**
     * 映射新的目标类型对象
     */
    public static <S, D> D map(S sourceObject, Class<D> destinationClass, boolean mapNulls) {
        return getMapperFacade(mapNulls).map(sourceObject, destinationClass);
    }

    public static <S, D> List<D> mapAsList(List<S> sourceObject, Class<D> destinationClass) {
        return getMapperFacade().mapAsList(sourceObject, destinationClass);
    }

}
