package com.c503.ca.cadv.common.util;

import lombok.extern.slf4j.Slf4j;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Created by IntelliJ IDEA. User: lj Date: 2009-8-21 Time: 16:11:20 To change
 * this template use File | Settings | File Templates.
 */
@Slf4j
public class Md5Utils {

    /**
     * 获得字符串s的md5 hash值.
     */
    public static String getMd5(String s) {
        String md5sum = "NULL";
        try {
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] hash = md5.digest(s.getBytes());
            md5sum = dumpBytes(hash);
        } catch (Exception e) {
            log.warn(e.toString());
        }
        return md5sum;
    }

    public static String generateToken(String sessionId) {

        String tokenStr = null;
        String currentTime = null;

        // 获取现在系统时间的字符串
        currentTime = System.currentTimeMillis() + "";

        // 使用MD5算法
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            // 把系统时间和sessionId都参与MD5运算
            md.update(currentTime.getBytes());

            md.update(sessionId.getBytes());

            // 获取MD5值
            byte[] tokenByte = md.digest();

            // 把MD5值转换为16进制字符串
            tokenStr = dumpBytes(tokenByte);
        } catch (NoSuchAlgorithmException e) {
            log.warn(e.toString());
        }

        return tokenStr;
    }

    private static String dumpBytes(byte[] bytes) {
        int size = bytes.length;
        StringBuilder sb = new StringBuilder(size * 2);
        String s;
        for (byte aByte : bytes) {
            s = Integer.toHexString(aByte);
            switch (s.length()) {
                case 8:
                    // -128 <= bytes[i] < 0
                    sb.append(s.substring(6));
                    break;
                case 2:
                    // 16 <= bytes[i] < 128
                    sb.append(s);
                    break;
                default:
                    // 0 <= bytes[i] < 16
                    sb.append("0").append(s);
                    break;
            }
        }
        return sb.toString();
    }

}
