package com.c503.ca.cadv.common.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.Map;

public class TemplateJsonUtil {

    //获取模板当中所有list，不包含batch（动态表格-子表）中的数据
    public static JSONArray geJsonArrayByTemplate(JSONObject object,JSONArray totleArray){

        //Json数据对象中不含List且含有model则表示该json数据对应模板当中的需填写的具体实列
        if(!object.containsKey("list")&&object.containsKey("model")){
            totleArray.add(object);
        }else if(object.containsKey("list")){
            //json数据含有batch表示该数据为动态表格，需进行特殊处理（根据动态表格创建子表），此处直接返回该值
            if("batch".equals(object.get("type"))){
                totleArray.add(object);
            }else {
                JSONArray jsonArray =object.getJSONArray("list");
                for (int i=0;i<jsonArray.size();i++){
                    JSONObject childObject= (JSONObject) jsonArray.get(i);
                    if(!childObject.containsKey("list")&&object.containsKey("model")){
                        totleArray.add(childObject);
                    }else{
                        geJsonArrayByTemplate(childObject,totleArray);
                    }
                }
            }
        }else{
            //处理Json模板组件中含有具体实例情况
            for (Map.Entry<String, Object> entry : object.entrySet()) {
                Object newObject=entry.getValue();
                if (newObject instanceof  JSONArray){
                    JSONArray itemJsonArray = (JSONArray) newObject;
                    for (int i=0;i<itemJsonArray.size();i++){
                        JSONObject itemObject= (JSONObject) itemJsonArray.get(i);
                        if(!itemObject.containsKey("list")&&object.containsKey("model")){
                            totleArray.add(itemObject);
                        }else{
                            geJsonArrayByTemplate(itemObject,totleArray);
                        }

                    }

                }else if (newObject instanceof  JSONObject){
                    JSONObject itemObject= (JSONObject) newObject;
                    geJsonArrayByTemplate(itemObject,totleArray);

                }
            }

        }
        return totleArray;
    }

    //获取batch(动态表格)中的所有组件
    public static JSONArray geJsonArrayByBatch(JSONObject object,JSONArray totleArray){
        //Json数据对象中不含List且含有model则表示该json数据对应模板当中的需填写的具体实列
        if(!object.containsKey("list")&&object.containsKey("model")){
            totleArray.add(object);
        }else{
            JSONArray jsonArray =object.getJSONArray("list");
            for (int i=0;i<jsonArray.size();i++){
                JSONObject childObject= (JSONObject) jsonArray.get(i);
                if(!childObject.containsKey("list")&&object.containsKey("model")){
                    totleArray.add(childObject);
                }else{
                    geJsonArrayByBatch(childObject,totleArray);
                }

            }
        }
        return totleArray;
    }


    //获取模板当中所有的组件数据
    public static JSONArray getAllJsonArrayByTemplate(JSONObject object,JSONArray totleArray){
        //Json数据对象中不含List且含有model则表示该json数据对应模板当中的需填写的具体实列
        if(!object.containsKey("list")&&object.containsKey("model")){
            totleArray.add(object);
        }else if(object.containsKey("list")){
            //json数据含有batch表示该数据为动态表格，需进行特殊处理（根据动态表格创建子表），此处直接返回该值


                JSONArray jsonArray =object.getJSONArray("list");
                boolean isBatch=false;

                //判断是否动态表格生成的属性字段
                if("batch".equals(object.get("type"))){
                    isBatch=true;
                }

                for (int i=0;i<jsonArray.size();i++){

                    JSONObject childObject= (JSONObject) jsonArray.get(i);
                    if(!childObject.containsKey("list")&&object.containsKey("model")){
                        if(isBatch){
                            //给动态表格中的字段加上该动态表格的唯一key值
                            childObject.put("parentKey",object.get("key"));
                        }
                        totleArray.add(childObject);
                    }else{
                        getAllJsonArrayByTemplate(childObject,totleArray);
                    }
                }

        }else{
            //处理Json模板组件中含有具体实例情况
            for (Map.Entry<String, Object> entry : object.entrySet()) {
                Object newObject=entry.getValue();
                if (newObject instanceof  JSONArray){
                    JSONArray itemJsonArray = (JSONArray) newObject;
                    for (int i=0;i<itemJsonArray.size();i++){
                        JSONObject itemObject= (JSONObject) itemJsonArray.get(i);
                        if(!itemObject.containsKey("list")&&object.containsKey("model")){
                            totleArray.add(itemObject);
                        }else{
                            getAllJsonArrayByTemplate(itemObject,totleArray);
                        }

                    }

                }else if (newObject instanceof  JSONObject){
                    JSONObject itemObject= (JSONObject) newObject;
                    getAllJsonArrayByTemplate(itemObject,totleArray);

                }
            }

        }
        return totleArray;
    }


}

