package com.c503.ca.cadv.common.util.domain;

/**
 * Redis常量
 * 命名规范：key: xxx-存储对象实体所在模块名-存储对象名称
 * 如果是hash存储，item：标识名称_唯一性标识
 */
public class CacheConstants {

    public static String sysName = "cadv:";
    public static String sysCommon = sysName + "common:";

    /**
     * 系统缓存key
     */
    public static final String CACHE_SYS = sysName + "uac:system";

    public static final String CACHE_USER_SESSIONS = CacheConstants.sysCommon + "sessions:";
    public static final String CACHE_USER_LAST = CacheConstants.sysCommon + "last";
    public static final String CACHE_USER_NOW = CacheConstants.sysCommon + "now";

    /**
     * 用户关联信息缓存key
     */
    public static final String CACHE_USER = sysName + "sys:user_relation_info";
    public static final String CACHE_ROLE_LIST = sysName + "sys:role_list";
    public static final String CACHE_DICT_MAP = sysName + "sys:dict_map";
    public static final String CACHE_DICT_LIST = sysName + "sys:dict_list";
    /**
     * 当前用户拥有的组织 菜单
     */
    public static final String CACHE_ORG_LIST = sysName + "sys:user:org_list";
    public static final String CACHE_MODULE_LIST = sysName + "sys:user:module_list";
    /**
     * 系统用户信息缓存key
     */
    public static final String USER_CACHE_ID_ = sysName + "sys:user_info:id_";
    public static final String USER_CACHE_LOGIN_NAME_ = sysName + "sys:user_info:ln_";
    public static final String FTP_CONFIG_INFO_CACHE = sysName + "cache:ftp-config:info:";

    /**
     * 权限模块映射对象，用于查询请求需要的权限
     */
    public static final String CACHE_MODULE_MAP = sysCommon + "system:module_map";
    public static final String CACHE_MODULE_MAP_VERSION = sysCommon + "system:module_map_version";

    public static final String CACHE_FILEDATA_ORDER = sysName + "dvc:inj:filedata:order";

    public static final String CACHE_INJPLAN_ORDER = sysName + "dvc:inj:injPlan:order";


    /**
     * FTP缓存
     */
    public static final String CACHE_FTP_ID_ = sysName + "ftp:id";
    public static final String CACHE_FTP_NAME_ = sysName + "ftp:name";

    /**
     * 任务缓存
     */
    public static final String CACHE_TASK_ID_ = sysName + "info:task:id";

    /**
     * 目标缓存
     */
    public static final String CACHE_TARGET_ID_ = sysName + "info:target:id";
    public static final String CACHE_TARGET_CODE_ = sysName + "info:target:code";
    public static final String CACHE_TARGET_NO_ = sysName + "info:target:no";

    /**
     * 目标主备信息缓存
     */
    public static final String CACHE_TARGETZB = sysName + "info:targetzb";

    public static final String CACHE_TARGETZB_STATUS = sysName + "info:targetzbstatus";

    public static final String CACHE_CAS_SYNC_STATUS = sysName + "cas:sync:status";

    public static final String CACHE_GEN_FM_LOCK = sysName + "genfm:lock";

    public static final String CACHE_REQID_ = sysName + "inj:reqId：";

    public static final String CACHE_TARGET_SYNC_STATUS = sysName + "target:sync:status";

    public static final String LOCK_CHECK_MASTER = sysName + "checkMaster";
}
