package com.c503.ca.cadv.common.util.jackson;

import com.c503.ca.cadv.common.util.DateUtils;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.deser.std.StdDeserializer;
import org.springframework.boot.jackson.JsonComponent;

import java.io.IOException;
import java.util.Date;

/**
 * 自定义 Date 类型的反序列化
 *
 * @author liaow
 */
@JsonComponent
public class DateDeserializer extends StdDeserializer<Date> {

    protected DateDeserializer(Class<Date> t) {
        super(t);
    }

    public DateDeserializer() {
        this(null);
    }

    @Override
    public Date deserialize(JsonParser p, DeserializationContext ctxt) throws IOException {
        return DateUtils.parseDate(p.getText());
    }

}
