package com.c503.ca.cadv.common.event;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import org.springframework.context.ApplicationEvent;

/**
 * @author liaow
 */
@Getter
@Setter
@EqualsAndHashCode(callSuper = true)
public class CacheEvictEvent extends ApplicationEvent {

    private String cacheKey;
    private String hashKey;

    public CacheEvictEvent(Object source, String cacheKey) {
        super(source);
        this.cacheKey = cacheKey;
    }

    public CacheEvictEvent(Object source, String cacheKey, String hashKey) {
        super(source);
        this.cacheKey = cacheKey;
        this.hashKey = hashKey;
    }
}
