package com.c503.ca.cadv.common.mvc;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.c503.ca.cadv.common.mvc.util.SqlUtils;
import com.google.common.collect.Lists;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;

import java.util.Iterator;
import java.util.List;

/**
 *
 */
public class PageQuery<T> extends Page<T> {

    private static final String PAGE = "page";
    private static final String LIMIT = "limit";
    private static final String ORDER_BY_FIELD = "orderByField";
    private static final String IS_ASC = "isAsc";

    public PageQuery(Class<T> clazz, Pageable pageable) {
        this(clazz, pageable, true);
    }

    public PageQuery(Class<T> clazz, Pageable pageable, boolean transSort) {

        super(pageable.getPageNumber()
            , pageable.getPageSize());

        if (transSort && pageable.getSort() != null) {
            Iterator<Sort.Order> iterator = pageable.getSort().iterator();
            List<OrderItem> orderItems = Lists.newArrayList();
            while (iterator.hasNext()) {
                Sort.Order order = iterator.next();
                String sqlField = SqlUtils.getSqlColumnByProperty(clazz, order.getProperty());

                if (order.getDirection().isAscending()) {
                    orderItems.add(OrderItem.asc(sqlField));
                } else if (order.getDirection().isDescending()) {
                    orderItems.add(OrderItem.desc(sqlField));
                }
            }
            addOrder(orderItems);
        }
    }

    public PageQuery(Integer page, Integer size) {
        super(page, size);
    }
}
