package com.c503.ca.cadv.common.mvc.domain;

import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;

/**
 * Entity支持类
 */
@Getter
@Setter
@EqualsAndHashCode(callSuper = true)
public abstract class BaseEntity extends Model implements Serializable {

    public static final String ENTITY_ID_REGEX = "^[,_'.@A-Za-z0-9-]*$";
    /*** 状态 审核 */
    public static final Integer STATUS_AUDIT = 1;
    /*** 状态 正常 */
    public static final Integer STATUS_NORMAL = 0;
    /*** 状态 锁定 */
    public static final Integer STATUS_DISABLE = -1;
    /*** 状态 锁屏 */
    public static final Integer STATUS_LOCK_SCREEN = -2;

    /**
     * 状态（-3:待审核,-2：删除；-1：停用 0：正常 1:审核）
     */
    public static final String F_STATUS = "status";
    /*** ID */
    public static final String F_ID = "id";
    public static final String F_CREATEDBY = "createdBy";
    public static final String F_CREATOR = "creator";
    public static final String F_CREATEDDATE = "createdDate";
    public static final String F_LASTMODIFIEDBY = "lastModifiedBy";
    public static final String F_MODIFIER = "modifier";
    public static final String F_LASTMODIFIEDDATE = "lastModifiedDate";
    public static final String F_VERSION = "version";
    public static final String F_DESCRIPTION = "description";
    public static final String F_SQL_ID = "id_";
    public static final String F_SQL_CREATEDBY = "created_by";
    public static final String F_SQL_CREATEDDATE = "created_date";
    public static final String F_SQL_LASTMODIFIEDBY = "last_modified_by";
    public static final String F_SQL_MODIFIER = "modifier";
    public static final String F_SQL_LASTMODIFIEDDATE = "last_modified_date";
    public static final String F_SQL_VERSION = "version_";
    public static final String F_SQL_DESCRIPTION = "description_";
    public static final String F_SQL_STATUS = "status_";
    private static final long serialVersionUID = 1L;

    public BaseEntity() {
        super();
    }

}
