package com.c503.ca.cadv.common.mvc.domain;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.Version;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.xml.bind.annotation.XmlTransient;
import java.util.Date;

/**
 * Base abstract class for entities which will hold definitions for created, last modified by and created,
 * last modified by date.
 */
@Data
@EqualsAndHashCode(callSuper = true)
public abstract class DataEntity extends BaseEntity {

    /*** 正常 */
    public static final Integer DELETED_NO = 0;
    /*** 已删除 */
    public static final Integer DELETED_YES = 1;

    private static final long serialVersionUID = 1L;
    //@JsonIgnore
    //@ApiModelProperty(hidden = true)
    @TableField(value = F_SQL_CREATEDBY, fill = FieldFill.INSERT)
    protected String createdBy;

    @TableField(value = F_SQL_CREATEDDATE, fill = FieldFill.INSERT)
    protected Date createdDate = new Date();

    @TableField(value = F_SQL_LASTMODIFIEDBY, fill = FieldFill.INSERT_UPDATE)
    protected String lastModifiedBy;

    @TableField(value = F_SQL_LASTMODIFIEDDATE, fill = FieldFill.INSERT_UPDATE)
    protected Date lastModifiedDate = new Date();

    /*** 默认0，必填，离线乐观锁 */
    @Version
    @JsonIgnore
    @XmlTransient
    @ApiModelProperty(hidden = true)
    @TableField(F_SQL_VERSION)
    protected Integer version = 0;

    @TableField(value = "deleted_")
    @TableLogic(value = "0", delval = "1")
    @JsonIgnore
    protected Integer deleted = DELETED_NO;

}
