package com.c503.ca.cadv.common.mvc.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

import java.io.Serializable;
import java.util.Objects;

/**
 * 主键策略：数据库自增
 *
 * @author liaow
 */
public class IdAutoEntity<PK extends Serializable> extends DataEntity {

    private static final long serialVersionUID = 1L;
    @TableId(value = F_SQL_ID, type = IdType.AUTO)
    protected PK id;

    public IdAutoEntity() {
        super();
    }

    @Override
    protected Serializable pkVal() {
        return getId();
    }

    public PK getId() {
        return id;
    }

    public void setId(PK id) {
        this.id = id;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        IdAutoEntity idEntity = (IdAutoEntity) o;
        if (idEntity.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), idEntity.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }
}
