package com.c503.ca.cadv.common.mvc.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.c503.ca.cadv.common.util.StringUtils;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * 数据TreeEntity类
 */
@SuppressWarnings({"rawtypes", "unused"})
@Data
@EqualsAndHashCode(callSuper = true)
public class TreeEntity<PK extends Serializable> extends DataEntity {

    public static final String ROOT = "1";
    public static final String F_NAME = "name";
    public static final String F_PARENTID = "parentId";
    public static final String F_PARENTIDS = "parentIds";
    public static final String F_ISLEAF = "isLeaf";
    public static final String F_SORT = "sort";
    public static final String F_PARENT = "parent";
    public static final String F_SQL_NAME = "name_";
    public static final String F_SQL_PARENTID = "parent_id";
    public static final String F_SQL_PARENTIDS = "parent_ids";
    public static final String F_SQL_ISLEAF = "is_leaf";
    public static final String F_SQL_SORT = "sort_";
    private static final long serialVersionUID = 1L;

    @TableId(value = F_SQL_ID, type = IdType.AUTO)
    protected PK id;

    /*** 组织名称 */
    @TableField(TreeEntity.F_SQL_NAME)
    protected String name;

    /*** 上级组织 */
    @TableField(TreeEntity.F_SQL_PARENTID)
    protected String parentId;

    /*** 所有父编号 */
    @TableField(TreeEntity.F_SQL_PARENTIDS)
    protected String parentIds;

    /*** 上级组织 */
    @TableField(exist = false)
    protected TreeEntity parent;

    /*** 序号 */
    @TableField(TreeEntity.F_SQL_SORT)
    protected Integer sort = 30;

    /*** 父模块名称 */
    @TableField(exist = false)
    protected String parentName;

    /*** 1 叶子节点 0非叶子节点 */
    @TableField(TreeEntity.F_SQL_ISLEAF)
    protected boolean leaf = false;

    public TreeEntity() {
        super();
    }

    public PK getId() {
        return this.id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getParentIds() {
        return parentIds;
    }

    public void setParentIds(String parentIds) {
        this.parentIds = parentIds;
    }

    public TreeEntity getParent() {
        return parent;
    }

    public void setParent(TreeEntity parent) {
        this.parent = parent;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public String getParentName() {
        if (parent != null && StringUtils.isNotEmpty(parent.getName())) {
            return parent.getName();
        }
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

}
