package com.c503.ca.cadv.common.mvc.repository;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;

import java.io.Serializable;
import java.util.Collection;

/**
 * DAO支持类实现
 * 用于后续拓展通用Sql
 */
public interface BaseRepository<T> extends BaseMapper<T> {

    /**
     * 物理删除（真删除，根据ID 批量删除）
     *
     * @param idList 主键ID列表(不能为 null 以及 empty)
     */
    @Delete("<script>" +
        "delete from ${tableName} where id_ in" +
        "<foreach collection='idList' item='id' open='(' separator=',' close=')'>" +
        "#{id}" +
        "</foreach>" +
        "</script>")
    int physicalDeleteBatchIds(@Param(value = "tableName") String tableName, @Param("idList") Collection<? extends Serializable> idList);

    /**
     * 物理删除（真删除）
     */
    @Delete("<script>" +
        "delete from ${tableName}" +
        "</script>")
    int physicalDeleteAll(@Param(value = "tableName") String tableName);

    /**
     * 物理删除（真删除，根据ID 批量删除）
     *
     * @param idList 主键ID列表(不能为 null 以及 empty)
     */
    @Delete("<script>" +
            "delete from ${tableName} where id_ = #{id}" +
            "</script>")
    int physicalDelete(@Param(value = "tableName") String tableName, @Param("id") Serializable id);

}
