package com.c503.ca.cadv.common.mvc.util;

import com.c503.ca.cadv.common.mvc.QueryDetail;
import com.c503.ca.cadv.common.util.domain.QueryCondition;

import java.util.List;

/**
 * 查询条件构造器工具
 *
 * @author liaow
 */
public class Querys {

    private Querys() {
    }

    public static <T> QueryDetail<T> createQuery(Class<T> entityClass, QueryCondition... queryConditions) {
        return new QueryDetail<T>(entityClass).and(queryConditions);
    }

    public static <T> QueryDetail<T> createQuery(Class<T> entityClass, String mainTableAlias, QueryCondition... queryConditions) {
        return new QueryDetail<T>(entityClass, mainTableAlias).and(queryConditions);
    }

    public static <T> QueryDetail<T> createQuery(Class<T> entityClass, List<QueryCondition> conditionList) {
        return new QueryDetail<>(entityClass).andAll(conditionList);
    }

    public static <T> QueryDetail<T> createQuery(Class<T> entityClass, String mainTableAlias, List<QueryCondition> conditionList) {
        return new QueryDetail<>(entityClass, mainTableAlias).andAll(conditionList);
    }

}
