package com.c503.ca.cadv.common.rest.base;

import com.c503.ca.cadv.common.mvc.domain.BaseEntity;
import com.c503.ca.cadv.common.mvc.domain.vo.TreeEntityVO;
import com.c503.ca.cadv.common.mvc.service.TreeVOService;
import com.c503.ca.cadv.common.util.domain.CustomMessage;
import com.c503.ca.cadv.common.util.domain.ResultBuilder;
import io.swagger.annotations.ApiImplicitParam;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.Optional;

/**
 * 基础控制器支持类
 */
public class TreeVOResource<Service extends TreeVOService, V extends TreeEntityVO> extends BaseResource {

    protected final Service service;

    public TreeVOResource(Service service) {
        this.service = service;
    }

    /**
     * @param id 对象ID
     * @return
     */
    @GetMapping("/{id:" + BaseEntity.ENTITY_ID_REGEX + "}")
    @ApiImplicitParam(name = "id", value = "实体ID", required = true, dataTypeClass = String.class, paramType = "path")
    public ResponseEntity<CustomMessage<V>> get(@PathVariable String id) {
        return ResultBuilder.wrapOrNotFound(Optional.ofNullable((V) service.findOneVO(id)));
    }
}
