package com.c503.ca.cadv.enhance.arthas;

import com.taobao.arthas.agent.attach.ArthasAgent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.actuate.endpoint.annotation.Endpoint;
import org.springframework.boot.actuate.endpoint.annotation.ReadOperation;

import java.util.HashMap;
import java.util.Map;

@Endpoint(id = "arthas")
public class ArthasEndPoint {
    @Autowired(required = false)
    private ArthasAgent arthasAgent;
    @Autowired(required = false)
    private HashMap<String, String> arthasConfigMap;

    public ArthasEndPoint() {
    }

    @ReadOperation
    public Map<String, Object> invoke() {
        Map<String, Object> result = new HashMap();
        if (this.arthasConfigMap != null) {
            result.put("arthasConfigMap", this.arthasConfigMap);
        }

        String errorMessage = this.arthasAgent.getErrorMessage();
        if (errorMessage != null) {
            result.put("errorMessage", errorMessage);
        }

        return result;
    }
}
