package com.c503.ca.cadv.enhance.ftp.config;

import lombok.Data;
import lombok.EqualsAndHashCode;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.pool2.impl.GenericKeyedObjectPoolConfig;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

@EqualsAndHashCode(callSuper = true)
@ConfigurationProperties("ftp")
@Configuration
@Data
public class FtpProperties extends GenericKeyedObjectPoolConfig<FTPClient> {

    /**
     * 与ftp交互时使用的文件编码，决定了操作ftp时的文件名字节编码
     */
    private String controlCharset = "UTF-8";

    private int maxTotal = Runtime.getRuntime().availableProcessors() * 4;

}
