package com.c503.ca.cadv.enhance.ftp.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * FTP配置
 * </p>
 *
 * @author liaow
 * @since 2020-03-10
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ftp_config")
public class FtpConfig extends IdAutoEntity<String> {

    private static final long serialVersionUID = 1L;

    /**
     * 名称
     */
    @TableField("name_")
    private String name;

    /**
     * 主机IP地址
     */
    @TableField("host")
    private String host;

    /**
     * 端口
     */
    @TableField("port")
    private Integer port;

    /**
     * 用户名
     */
    @TableField("username")
    private String username;

    /**
     * 密码
     */
    @TableField("password")
    private String password;

    /**
     * 是否被动模式
     */
    @TableField("passive")
    private boolean passive = true;

    /**
     * 本地接收路径
     */
    @TableField("local_path")
    private String localPath;

    /**
     * 目标路径
     */
    @TableField("server_path")
    private String serverPath;

    /**
     * 服务器存档目录
     */
    @TableField("server_archive_path")
    private String serverArchivePath;
    /**
     * 服务器存档目录
     */
    @TableField("server_send_path")
    private String serverSendPath;


}
