package com.c503.ca.cadv.enhance.ftp.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * FTP配置
 * </p>
 *
 * @author liaow
 * @since 2020-03-10
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "FtpConfig对象", description = "FTP配置")
public class FtpConfigVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "名称")
    private String name;

    @ApiModelProperty(value = "主机IP地址")
    private String host;

    @ApiModelProperty(value = "端口", example = "1")
    private Integer port;

    @ApiModelProperty(value = "用户名")
    private String username;

    @ApiModelProperty(value = "密码")
    private String password;

    @ApiModelProperty(value = "是否被动模式", example = "1")
    private Boolean passive;

    @ApiModelProperty(value = "本地接收路径")
    private String localPath;

    @ApiModelProperty(value = "目标路径")
    private String serverPath;

    @ApiModelProperty(value = "服务器归档目录，如果配置则下载文件后移动到此目录")
    private String serverArchivePath;

}
