package com.c503.ca.cadv.enhance.quartz.excutor;

import com.c503.ca.cadv.enhance.quartz.domain.TaskScheduleJob;
import com.c503.ca.cadv.enhance.quartz.util.TaskScheduleUtils;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.stereotype.Component;

/**
 * @Description: 若一个方法一次执行不完下次轮转时则等待改方法执行完后才执行下一次操作
 */
@Component
@DisallowConcurrentExecution
public class QuartzJobFactoryDisallowConcurrentExecution implements Job {


    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {
        TaskScheduleJob taskScheduleJob = (TaskScheduleJob) context.getMergedJobDataMap().get("taskScheduleJob");
        TaskScheduleUtils.invokMethod(taskScheduleJob);
    }
}
