package com.c503.ca.cadv.enhance.quartz.util;

import com.c503.ca.cadv.common.util.DateUtils;
import com.c503.ca.cadv.common.util.StringUtils;
import com.c503.ca.cadv.common.constant.SystemConstants;
import com.fasterxml.jackson.annotation.JsonIgnore;
import org.apache.commons.lang3.math.NumberUtils;

import java.text.ParseException;

/**
 * Created by ftp on 2017/1/24.
 */
public class TaskTargetParam {
    private String attrType = SystemConstants.TYPE_STRING;
    private String format;
    private String value;

    public TaskTargetParam() {
    }

    public TaskTargetParam(String value) {
        this.value = value;
    }

    public TaskTargetParam(String attrType, String value) {
        this.attrType = attrType;
        this.value = value;
    }

    public TaskTargetParam(String attrType, String format, String value) {

        this.attrType = attrType;
        this.format = format;
        this.value = value;
    }

    public String getAttrType() {
        return attrType;
    }

    public void setAttrType(String attrType) {

        this.attrType = attrType;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @JsonIgnore
    public Object getRelValue() {
        String type = attrType;
        Object val = null;
        if (value != null) {
            if (StringUtils.isNotEmpty(type)) {
                if (SystemConstants.TYPE_STRING.equalsIgnoreCase(type)) {
                    val = String.valueOf(value);
                } else if (SystemConstants.TYPE_INTEGER.equalsIgnoreCase(type) || SystemConstants.TYPE_INT.equalsIgnoreCase(type)) {
                    val = NumberUtils.toInt(String.valueOf(value));
                } else if (SystemConstants.TYPE_LONG.equalsIgnoreCase(type)) {
                    val = NumberUtils.toLong(String.valueOf(value));
                } else if (SystemConstants.TYPE_SHORT.equalsIgnoreCase(type)) {
                    val = NumberUtils.toShort(String.valueOf(value));
                } else if (SystemConstants.TYPE_FLOAT.equalsIgnoreCase(type)) {
                    val = NumberUtils.toFloat(String.valueOf(value));
                } else if (SystemConstants.TYPE_DOUBLE.equalsIgnoreCase(type)) {
                    val = NumberUtils.toDouble(String.valueOf(value));
                } else if (SystemConstants.TYPE_DATE.equalsIgnoreCase(value)) {
                    try {
                        val = DateUtils.parseDate(value, format);
                    } catch (ParseException e) {
                        e.printStackTrace();
                    }
                }
            }
        }
        return val;
    }

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }
}
