package com.c503.ca.cadv.enhance.redis.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;

/*
* #集群配置
spring.redis.cluster.scan-interval=1000
spring.redis.cluster.nodes=
spring.redis.cluster.read-mode=SLAVE
spring.redis.cluster.retry-attempts=3
spring.redis.cluster.failed-attempts=3
spring.redis.cluster.slave-connection-pool-size=64
spring.redis.cluster.master-connection-pool-size=64
spring.redis.cluster.retry-interval=1500
#哨兵配置
spring.redis.sentinel.master=business-master
spring.redis.sentinel.nodes=
spring.redis.sentinel.master-onlyWrite=true
spring.redis.sentinel.fail-max=3
---------------------
原文：https://blog.csdn.net/qq_33814088/article/details/83347757
* */

@Data
@ConfigurationProperties(prefix = "spring.redis", ignoreUnknownFields = true)
public class RedisProperties {

    private int database;

    /**
     * 等待节点回复命令的时间。该时间从命令发送成功时开始计时
     */
    private int timeout;

    private String host;

    private String port = "6379";

    private String password;

    private Integer retryInterval = 5000;

    /**
     * 默认单机模式
     * 提供三种模式：single、cluster、sentinel
     */
    private String mode = "single";

    /**
     * redission池配置
     */
    private RedisPoolProperties redissionPool = new RedisPoolProperties();

    /**
     * 池配置
     */
    private RedisPoolProperties lettucePool = new RedisPoolProperties();

    /**
     * 集群 信息配置
     */
    private RedisClusterProperties cluster;

    /**
     * 哨兵配置
     */
    private RedisSentinelProperties sentinel;

    private boolean ssl = false;

}
