package com.c503.ca.cadv.enhance.websocket.config;

import com.c503.ca.cadv.common.util.JacksonUtils;
import com.c503.ca.cadv.enhance.websocket.domain.WebSocketMessage;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Component
public class RedisReceiver {

	@Resource
	private SimpMessagingTemplate messagingTemplate;

	/**
	 * 发送消息
	 * @param message
	 */
	public void sendQueueMsg(Object message) {

	}

	/**
	 * 根据帐号发送消息
	 * @param message
	 */
	public void sendUserMsg(Object message){
		WebSocketMessage webSocketMessage = coverterMessage(message);
		if(webSocketMessage != null){
			messagingTemplate.convertAndSend(WebSocketConstants.TOPIC_USER + webSocketMessage.getUserId(), webSocketMessage);
		}
	}

	/**
	 * 根据topic发送广播消息
	 * @param message
	 */
	public void sendTopicMsg(Object message) {
		WebSocketMessage webSocketMessage = coverterMessage(message);
		if(webSocketMessage != null){
			String topic = webSocketMessage.getTopicType();
			if(WebSocketConstants.TOPIC_BROADCAST.equals(topic)){
				messagingTemplate.convertAndSend(WebSocketConstants.TOPIC_BROADCAST, webSocketMessage);
			}else{
				topic = topic.startsWith("/") ? topic : "/" + topic;
				topic = topic.startsWith("/topic") ? topic : "/topic" + topic;
				messagingTemplate.convertAndSend(topic, webSocketMessage);
			}
		}

	}

	private WebSocketMessage coverterMessage(Object message) {
		try {
			return JacksonUtils.fromJsonString((String)message,WebSocketMessage.class);
		} catch (Exception e) {
			return null;
		}
	}

}
