package com.c503.ca.cadv.module.check.domain;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class CompResult<T, K> {
    private T obj;
    private K compObj;
    private Integer result;
    private String fileName;


    /**
     * 无需比较
     **/
    public static final int NO_COMP = 1;
    /**
     * 相同
     **/
    public static final int COMP_EQUAL = 2;
    /**
     * 不同
     **/
    public static final int COMP_NO_EQUAL = 3;
    /**
     * 不在取值范围内或不在长度范围内
     */
    public static final int OUT_RANGE = 4;
    /**
     * 比对中断
     **/
    public static final int COMP_BREAK = 5;
    /**
     * 参数值非文件名
     **/
//    public static final int COMP_NEED_FILENAME_BUT_NON = 5;
    /**
     * 文件不存在
     **/
//    public static final int COMP_FILE_NO_EXIST = 6;
    /**
     * 获取文件失败
     **/
//    public static final int COMP_GET_FILE_FAIL = 7;
    /**
     * 比对代码不同
     */
    public static final int COMP_CODE_NO_EQUAL = 8;
    /**
     * 无比对对象
     */
    public static final int COMP_NO_OBJ = 9;

    /**
     * 无文件值
     */
    public static final int COMP_NO_FILE_VALUE = 6;

}
