package com.c503.ca.cadv.module.check.util;

import serv.jcml.JCML;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author hyx
 * @Date 2024/6/17 16:30
 */
public class ThreadLocalUtil {

    private static ThreadLocal<Map<String, Object>> tempLocal = new ThreadLocal<>();

    private static ThreadLocal<Map<String, String>> resultLocal = new ThreadLocal<>();

    public static void setTempLocal(String key, Object value) {
        Map<String, Object> tempMap = tempLocal.get();
        if (tempMap == null) {
            tempMap = new HashMap<>();
            tempMap.put(key, value);
        } else {
            tempMap.put(key, value);
        }
        tempLocal.set(tempMap);
    }

    public static Object getTempLocal(String key) {
        Map<String, Object> tempMap = tempLocal.get();
        if (tempMap != null) {
            return tempMap.get(key);
        }
        return null;
    }

    public static void clearTempLocal() {
        Map<String, Object> tempMap = tempLocal.get();
        if (tempMap != null) {
            for (Map.Entry entry : tempMap.entrySet()) {
                JCML jcml = (JCML) entry.getValue();
                jcml.cmlFreeDocHandler();
            }
        }
        tempLocal.remove();
    }

    public static void setResultLocal(String key, String value) {
        Map<String, String> tempMap = resultLocal.get();
        if (tempMap == null) {
            tempMap = new HashMap<>();
            tempMap.put(key, value);
        } else {
            tempMap.put(key, value);
        }
        resultLocal.set(tempMap);
    }

    public static String getResultLocal(String key) {
        Map<String, String> tempMap = resultLocal.get();
        if (tempMap != null) {
            return tempMap.get(key);
        }
        return null;
    }

    public static void clearResultLocal() {
        resultLocal.remove();
    }
}
