package com.c503.ca.cadv.module.cluster.core.model;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 负载均衡集群
 *
 * @author Mr.Lee
 * @date 2021/06/21 17:41
 **/

@Component
public class Cluster {

	// 集群的名称
	@Value("${cluster.name}")
	private String nodeName;

	// 本地服务地址
	@Autowired
	private Node local;

	// 集群中的所有节点
	private List<Node> nodes;

	public String getNodeName() {
		return nodeName;
	}

	public void setNodeName(String nodeName) {
		this.nodeName = nodeName;
	}

	public List<Node> getNodes() {
		return nodes;
	}

	public void setNodes(List<Node> nodes) {
		this.nodes = nodes;
	}

	public Node getLocal() {
		return local;
	}

	public void setLocal(Node local) {
		this.local = local;
	}
}
