package com.c503.ca.cadv.module.cluster.core.model;

import java.io.Serializable;
import java.util.Objects;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * 负载均衡集群中的节点
 *
 * @author Mr.Lee
 * @date 2021/06/21 17:39
 **/
@Component
public class Node implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7505625291027792510L;

	// 节点提供的服务的IP：127.0.0.1
	@Value("${cluster.local.ip}")
	private String ip;

	// 节点心跳端口
	@Value("${cluster.local.heart-beat-port}")
	private int heartBeatPort;

	// 节点在集群中的角色：master,slave
	private String role = "slave";

	// 预留字段：节点权重，默认为0
	@Value("${cluster.local.score}")
	private int score = 0;

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.ip = ip;
	}

	public int getHeartBeatPort() {
		return heartBeatPort;
	}

	public void setHeartBeatPort(int heartBeatPort) {
		this.heartBeatPort = heartBeatPort;
	}

	public String getRole() {
		return role;
	}

	public void setRole(String role) {
		this.role = role;
	}

	public int getScore() {
		return score;
	}

	public void setScore(int score) {
		this.score = score;
	}

	@Override
	public String toString() {
		return "[Node->"+ ip + "]";
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		Node nodeInfo = (Node) o;
		return heartBeatPort == nodeInfo.heartBeatPort &&
				Objects.equals(ip, nodeInfo.ip);
	}

	@Override
	public int hashCode() {
		return Objects.hash(ip, heartBeatPort);
	}

}
