package com.c503.ca.cadv.module.cluster.loadbalance.algorithm;

import java.util.List;

import com.c503.ca.cadv.module.cluster.core.model.Node;

/**
 * 负载均衡决策者，这里使用策略模式实现对不同算法的支持,策略模式使得算法可以在不影响到客户端的情况下发生变化
 *
 * @author Mr.Lee
 * @date 2021/07/05 11:40
 **/
public interface ICalculatStrategy{

    /** 
     * @Description: 负载均衡计算，决策由哪个节点执行
     * @Author: Mr.Lee
     * @Date: 2021-7-5 11:55
     * @Param: 
     * @Return: 
     */
    Node calculate(List<Node> nodesList);

}
