package com.c503.ca.cadv.module.cluster.loadbalance.algorithm;


import java.security.SecureRandom;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

import com.c503.ca.cadv.module.cluster.core.model.Node;

/**
 * 负载均衡算法：随机法
 *
 * 负载均衡方法随机的把负载分配到各个可用的服务器上，通过随机数生成算法选取一个服务器。
 * @author Mr.Lee
 * @date 2021/06/21 17:51
 **/
public class Randomizing implements ICalculatStrategy{

    //    1.定义map, key-ip,value-weight
    static Map<String,Integer> ipMap=new HashMap<>();
    static {
        ipMap.put("192.168.13.1",1);
        ipMap.put("192.168.13.2",2);
        ipMap.put("192.168.13.3",4);

    }
    public String calculate() {
        Map<String,Integer> ipServerMap = new ConcurrentHashMap<>();
        ipServerMap.putAll(ipMap);

        Set<String> ipSet = ipServerMap.keySet();
        //定义一个list放所有server
        ArrayList<String> ipArrayList = new ArrayList<String>();
        ipArrayList.addAll(ipSet);

        //循环随机数
        Random random = new SecureRandom();
        //随机数在list数量中取（1-list.size）
        int pos = random.nextInt(ipArrayList.size());
        String serverNameReturn = ipArrayList.get(pos);
        return  serverNameReturn;
    }


    @Override
    public Node calculate(List<Node> nodesList) {
        return null;
    }
}
