package com.c503.ca.cadv.module.cluster.loadbalance.algorithm;

import java.security.SecureRandom;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

import com.c503.ca.cadv.module.cluster.core.model.Node;

/**
 * 负载均衡算法：加权随机法
 *
 * 获取带有权重的随机数字，随机的方法，不能看绝对，只能看相对。
 * @author Mr.Lee
 * @date 2021/06/21 17:53
 **/
public class RobinRandom implements ICalculatStrategy{
    //    1.定义map, key-ip,value-weight
    static Map<String,Integer> ipMap = new HashMap<>();
    static {
        ipMap.put("192.168.13.1",1);
        ipMap.put("192.168.13.2",2);
        ipMap.put("192.168.13.3",4);
    }

    public String calculate(){
        Map<String,Integer> ipServerMap =new ConcurrentHashMap<>();
        ipServerMap.putAll(ipMap);

        Set<String> ipSet = ipServerMap.keySet();
        Iterator<String> ipIterator = ipSet.iterator();

        //定义一个list放所有server
        ArrayList<String> ipArrayList = new ArrayList<String>();

        //循环set，根据set中的可以去得知map中的value，给list中添加对应数字的server数量
        while (ipIterator.hasNext()){
            String serverName = ipIterator.next();
            Integer weight = ipServerMap.get(serverName);
            for (int i = 0;i < weight; i++){
                ipArrayList.add(serverName);
            }
        }

        //循环随机数
        SecureRandom random=new SecureRandom();
        //随机数在list数量中取（1-list.size）
        int pos=random.nextInt(ipArrayList.size());
        String serverNameReturn= ipArrayList.get(pos);
        return  serverNameReturn;
    }

    @Override
    public Node calculate(List<Node> nodesList) {
        return null;
    }
}
