/*
* Copyright &copy; 2020-2021  c503-htphy All rights reserved.
*/
package com.c503.ca.cadv.module.cmp.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.apache.commons.lang.StringUtils;

@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("cmp_fill_config")
public class FillConfig extends IdAutoEntity<String> {

    private static final long serialVersionUID = 1L;

    /**
    * 注入数据
    */
    @TableField("inj_type")
    private String injType;

    /**
    * 生成模式
    */
    @TableField("generate_mode")
    private String generateMode;

    /**
    * 时间偏移量
    */
    @TableField("time_offset")
    private Double timeOffset;

    /**
    * 增加的指令代号
    */
    @TableField("add_cmd_code")
    private String addCmdCode;

    /**
    * 删除的指令代号
    */
    @TableField("del_cmd_code")
    private String delCmdCode;

    /**
    * 参数上限条数
    */
    @TableField("uppper_limit")
    private Integer uppperLimit;

    @TableField("target_code")
    private String targetCode;

    @TableField("is_dc")
    private Integer isDc;

    @Override
    public String toString() {
        return "{" +
                "injType='" + (StringUtils.isNotEmpty(injType) ? injType : "") + '\'' +
                ", generateMode='" + (StringUtils.isNotEmpty(generateMode) ? generateMode : "") + '\'' +
                ", timeOffset=" + (timeOffset != null ? timeOffset.toString() : "") +
                ", addCmdCode='" + (StringUtils.isNotEmpty(addCmdCode) ? addCmdCode : "") + '\'' +
                ", delCmdCode='" + (StringUtils.isNotEmpty(delCmdCode) ? delCmdCode : "") + '\'' +
                ", uppperLimit=" + (uppperLimit != null ? uppperLimit.toString() : "") +
                ", isDc=" + (isDc != null ? isDc.toString() : "") +
                '}';
    }

}
