/*
* Copyright &copy; 2020-2021  c503-htphy All rights reserved.
*/
package com.c503.ca.cadv.module.cmp.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;


@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value="FillConfig对象", description="比对信息填充配制表")
public class FillConfigVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "注入数据")
    private String injType;

    @ApiModelProperty(value = "生成模式")
    private String generateMode;

    @ApiModelProperty(value = "时间偏移量", example = "1")
    private Double timeOffset;

    @ApiModelProperty(value = "增加的指令代号")
    private String addCmdCode;

    @ApiModelProperty(value = "删除的指令代号")
    private String delCmdCode;

    @ApiModelProperty(value = "参数上限条数", example = "1")
    private Integer uppperLimit;

    @ApiModelProperty(value = "目标码")
    private String targetCode;

    @ApiModelProperty(value = "是否代传")
    private Integer isDc;

}
