package com.c503.ca.cadv.module.config.domain;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Set;

/**
 * 用户信息
 */
@Getter
@Setter
public class LoginUser implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 会话唯一标识
     */
    private String token;

    private String tgc;

    /**
     * 用户名id
     */
    private String userId;

    /**
     * 用户名/登录名
     */
    private String username;

    /**
     * 登录时间
     */
    private Long loginTime;

    /**
     * 过期时间
     */
    private Long expireTime;

    /**
     * 登录IP地址
     */
    private String ipaddr;

    /**
     * 权限列表
     */
    private Set<String> permissions;

    /**
     * 角色列表
     */
    private Set<String> roles;
    /**
     * 岗位列表
     */
    private Set<String> jobs;

    /**
     * 用户信息
     */
    private UserDTO user;

    /**
     * 浏览器类型
     */
    private String browser;
    /**
     * 浏览器版本
     */
    private String browserVersion;

    /**
     * 操作系统
     */
    private String os;
}
