package com.c503.ca.cadv.module.config.domain;

import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;

/**
 * 用户Session信息，相比LoginUser进行精简
 */
@Getter
@Setter
public class OnlineSession implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 会话唯一标识
     */
    private String token;

    /**
     * 用户名id
     */
    private String userId;

    /**
     * 用户名/登录名
     */
    private String username;

    /**
     * 登录时间
     */
    private Long loginTime;

    /**
     * 过期时间
     */
    private Long expireTime;

    /**
     * 登录IP地址
     */
    private String ipaddr;

    /**
     * 浏览器类型
     */
    private String browser;
    /**
     * 浏览器版本
     */
    private String browserVersion;

    /**
     * 操作系统
     */
    private String os;

}
