package com.c503.ca.cadv.module.config.interceptor;

import com.c503.ca.cadv.common.util.LocaleMessageUtils;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.LocaleResolver;
import org.springframework.web.servlet.support.RequestContextUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Locale;

/**
 * 国际化拦截器
 *
 * @author liaow
 */
public class LocaleInterceptor implements HandlerInterceptor {

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) {
        LocaleResolver resolver = RequestContextUtils.getLocaleResolver(request);
        if (resolver == null) {
            return true;
        }
        Locale locale = resolver.resolveLocale(request);
        LocaleMessageUtils.setCurrentLocale(locale);
        return true;
    }
}
