package com.c503.ca.cadv.module.config.sharding.config;

import com.zaxxer.hikari.HikariConfig;
import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Component
@ConfigurationProperties(prefix = "spring.shardingsphere.datasource.calp", ignoreInvalidFields = true)
@Data
public class ShardingDbConfiguration {
    private String driverClassName;
    private String type;
    private String jdbcUrl;
    private String username;
    private String password;

    private DbParams hikari;

    public HikariConfig newHikariConfigInstance(String jdbcUrl, String poolName){
        HikariConfig config = new HikariConfig();
        config.setDriverClassName(this.driverClassName);
        config.setJdbcUrl(jdbcUrl);
        config.setUsername(this.username);
        config.setPassword(this.password);

        config.setConnectionTimeout(this.hikari.getConnectionTimeout());
        config.setMinimumIdle(this.hikari.getMinimumIdle());
        config.setMaximumPoolSize(this.hikari.getMaximumPoolSize());
        config.setAutoCommit(this.hikari.isAutoCommit());
        config.setIdleTimeout(this.hikari.getIdleTimeout());
        config.setPoolName(poolName);
        config.setMaxLifetime(this.hikari.getMaxLifetime());
        config.setConnectionTestQuery(this.hikari.getConnectionTestQuery());
        config.setRegisterMbeans(this.hikari.isRegisterMbeans());

        return config;
    }

}
