package com.c503.ca.cadv.module.fm.service;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

@Slf4j
@Component
@Order(100)
public class LoadSOService implements CommandLineRunner {

    @Override
    public void run(String... args) throws Exception {
        log.info("load so begin");
        log.info("java library path:[{}]", System.getProperty("java.library.path"));
        String BTAS3 = System.getenv("BTAS3");
        log.info("sys env:[{}]", BTAS3);

        try {
            String libJZFMPath = BTAS3 + "/f/fm/lib/libJZFM.so";
            System.load(libJZFMPath);
            log.info("load libJZFM.so[{}] finished", libJZFMPath);
        } catch (UnsatisfiedLinkError error) {
            log.error("load so error:{}", error.toString());
        }

        try {
            String libJZFIPath = BTAS3 + "/com/lib/libJZFI.so";
            System.load(libJZFIPath);
            log.info("load libJZFI.so[{}] finished", libJZFIPath);
        } catch (UnsatisfiedLinkError error) {
            log.error("load so error:{}", error.toString());
        }

        try {
            String libJZFLPath = BTAS3 + "/f/fl/lib/libJZFL.so";
            System.load(libJZFLPath);
            log.info("load libJZFL.so[{}] finished", libJZFLPath);
        } catch (UnsatisfiedLinkError error) {
            log.error("load so error:{}", error.toString());
        }

        try {
            String libJZFFPath = BTAS3 + "/f/ff/lib/libJZFF.so";
            System.load(libJZFFPath);
            log.info("load libJZFF.so[{}] finished", libJZFFPath);
        } catch (UnsatisfiedLinkError error) {
            log.error("load so error:{}", error.toString());
        }

        log.info("load so finished");
    }
}
