/**
 * Copyright &copy; 2020-2021  c503-htphy All rights reserved.
 */
package com.c503.ca.cadv.module.ge.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import com.google.common.collect.Lists;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * <p>
 * 通用指令表
 * </p>
 *
 * @author jintch
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ge_cmd")
public class Cmd extends IdAutoEntity<String> {

    private static final long serialVersionUID = 1L;

    /**
     * 任务码
     */
    @TableField("mission_no")
    private String missionNo;

    /**
     * 目标码
     */
    @TableField("object_code")
    private String objectCode;

    /**
     * 指令序号
     */
    @TableField("cmd_no")
    private String cmdNo;

    /**
     * 指令代号
     */
    @TableField("cmd_code")
    private String cmdCode;

    /**
     * 指令名称
     */
    @TableField("cmd_name")
    private String cmdName;

    /**
     * 识别字
     */
    @TableField("key_str")
    private String keyStr;

    @TableField(exist = false)
    private List<CmdParam> cmdParamList = Lists.newArrayList();
}
