/**
 * Copyright &copy; 2020-2021  c503-htphy All rights reserved.
 */
package com.c503.ca.cadv.module.ge.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 通用指令参数表
 * </p>
 *
 * @author jintch
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ge_cmd_param")
public class CmdParam extends IdAutoEntity<String> {

    private static final long serialVersionUID = 1L;

    /**
     * 所属指令ID
     */
    @TableField("cmd_id")
    private String cmdId;

    @TableField("code_")
    private String code;

    @TableField("group_no")
    private String groupNo;

    @TableField("no_in_group")
    private String noInGroup;

    /**
     * 参数序号
     */
    @TableField("data_no")
    private Integer dataNo;

    /**
     * 长度
     */
    @TableField("len_")
    private Integer len;

    /**
     * 参数类型
     */
    @TableField("type_")
    private Integer type;

    /**
     * 量纲
     */
    @TableField("dimen_")
    private String dimen;

    /**
     * 标称值
     */
    @TableField("fix_")
    private String fix;


    /**
     * 意义
     */
    @TableField("explain_")
    private String explain;

    /**
     * 取值路径
     */
    @TableField("para_path")
    private String paraPath;

    /**
     * 取值范围
     */
    @TableField("value_range")
    private String valueRange;

    @TableField("sz_para_code")
    private String szParaCode;

    /**
     * 目标码
     */
    @TableField("object_code")
    private String objectCode;
}
