/**
 * Copyright &copy; 2020-2021  c503-htphy All rights reserved.
 */
package com.c503.ca.cadv.module.ge.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Objects;

/**
 * <p>
 * 通用指令参数表
 * </p>
 *
 * @author jintch
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "CmdParam对象", description = "通用指令参数表")
public class CmdParamVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "所属指令ID", example = "1")
    private String cmdId;

    private String code;

    private String groupNo;

    private String noInGroup;

    @ApiModelProperty(value = "参数序号", example = "1")
    private Integer dataNo;

    @ApiModelProperty(value = "长度", example = "1")
    private Integer len;

    @ApiModelProperty(value = "参数类型", example = "1")
    private Integer type;

    @ApiModelProperty(value = "量纲")
    private String dimen;

    @ApiModelProperty(value = "标称值")
    private String fix;

    @ApiModelProperty(value = "意义")
    private String explain;

    @ApiModelProperty(value = "取值路径")
    private String paraPath;

    @ApiModelProperty(value = "取值范围")
    private String valueRange;

    @ApiModelProperty(value = "指令参数编码")
    private String szParaCode;

    private String typeStr;
    private String lenStr;
    private String dataNoStr;
    private String method;

    private String value;

    private String objectCode;

    @Override
    public boolean equals(Object o) {
        if(o instanceof CmdParamVO){
            CmdParamVO that = (CmdParamVO) o;
            if (!Objects.equals(code, that.code)) return false;
            if (!Objects.equals(groupNo, that.groupNo)) return false;
            if (!Objects.equals(noInGroup, that.noInGroup)) return false;
            if (!Objects.equals(dataNo, that.dataNo)) return false;
            if (!Objects.equals(len, that.len)) return false;
            if (!Objects.equals(type, that.type)) return false;
            if (!Objects.equals(dimen, that.dimen)) return false;
            if (!Objects.equals(fix, that.fix)) return false;
            if (!Objects.equals(explain, that.explain)) return false;
            if (!Objects.equals(valueRange, that.valueRange)) return false;
            return Objects.equals(paraPath, that.paraPath);
        }else{
            return false;
        }

    }
}
