/**
 * Copyright &copy; 2020-2021  c503-htphy All rights reserved.
 */
package com.c503.ca.cadv.module.ge.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import com.google.common.collect.Lists;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;
import java.util.Objects;

/**
 * <p>
 * 通用指令表
 * </p>
 *
 * @author jintch
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "Cmd对象", description = "通用指令表")
public class CmdVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "任务码")
    private String missionNo;

    @ApiModelProperty(value = "目标码")
    private String objectCode;

    @ApiModelProperty(value = "指令序号")
    private String cmdNo;

    @ApiModelProperty(value = "指令代号")
    private String cmdCode;

    @ApiModelProperty(value = "指令名称")
    private String cmdName;

    @ApiModelProperty(value = "识别字")
    private String keyStr;

    private List<CmdParamVO> cmdParamVOList = Lists.newArrayList();

    private String objectName;

    private String filename;

    @Override
    public boolean equals(Object o) {
        if (o == null) return false;
        CmdVO cmdVO = (CmdVO) o;
        if (!Objects.equals(objectCode, cmdVO.objectCode)) return false;
        return Objects.equals(cmdCode, cmdVO.cmdCode);
    }
}
