package com.c503.ca.cadv.module.ge.domain.xdo;

import com.c503.ca.cadv.common.util.StringUtils;
import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import lombok.Data;

import java.util.List;

/**
 * @author jintch
 * @since 2021/2/20
 */
@Data
@XStreamAlias("stV_ZrBlk")
public class CmdParamXDO {

    @XStreamAlias("szCode")
    private String code;

    @XStreamAlias("szGroupno")
    private String groupNo;

    @XStreamAlias("szNoInGroup")
    private String noInGroup;

    /**
     * 参数序号
     */
    @XStreamAlias("szDataNo")
    private Integer dataNo;

    /**
     * 长度
     */
    @XStreamAlias("szLen")
    private Integer len;

    /**
     * 参数类型
     */
    @XStreamAlias("szType")
    private Integer type;

    /**
     * 量纲
     */
    @XStreamAlias("szDimen")
    private String dimen;

    /**
     * 标称值
     */
    @XStreamAlias("szFix")
    private String fix;

    /**
     * 意义
     */
    @XStreamAlias("szExplain")
    private String explain;


    /**
     * 取值路径
     */
    @XStreamAlias("szParaPath")
    private String paraPath;

    /**
     * 参数代号
     */
    @XStreamAlias("szParaCode")
    private String szParaCode;

    /**
     * 取值范围
     */
    @XStreamImplicit(itemFieldName = "stObjtCmvInfo")
    private List<ValueRangeXDO> valueRangeXDOList;

    private String valueRange;

    /**
     * 操作符：12 （=） 页面输出：=值1
     * 6 (闭区间) 页面输出： 值1 ~ 值2
     * 其他操作符 页面输出： 值1（tab）值2
     * <p>
     * 多个取值范围之间是或的关系
     *
     * @return 取值范围
     */
    public String getValueRange() {
        if (getValueRangeXDOList() != null) {
            String equal = "=";
            String wavyLine = "~";
            String tab = "\t";
            String space = " ";
            String or = "|";
            StringBuilder stringBuilder = new StringBuilder();
            List<ValueRangeXDO> valueRangeXDOList = getValueRangeXDOList();
            for (int i = 0; i < valueRangeXDOList.size(); i++) {
                ValueRangeXDO valueRangeXDO = valueRangeXDOList.get(i);
                if (ValueRangeXDO.OPT_SIGN_EQUAL == valueRangeXDO.getOPTSign()) {
                    stringBuilder.append(equal).append(valueRangeXDO.getValue1());
                } else if (ValueRangeXDO.CLOSED_INTERVAL == valueRangeXDO.getOPTSign()) {
                    stringBuilder.append(valueRangeXDO.getValue1()).append(wavyLine).append(valueRangeXDO.getValue2());
                } else {
                    stringBuilder.append(valueRangeXDO.getValue1()).append(tab).append(valueRangeXDO.getValue2());
                }
                if (StringUtils.isNotEmpty(valueRangeXDO.getMean())) {
                    stringBuilder.append(space).append(valueRangeXDO.getMean());
                }
                if (i < valueRangeXDOList.size() - 1) {
                    stringBuilder.append(or);
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
