/**
 * Copyright &copy; 2020-2021  c503-htphy All rights reserved.
 */
package com.c503.ca.cadv.module.ge.service;

import com.c503.ca.cadv.common.mvc.service.DataVOService;
import com.c503.ca.cadv.module.ge.domain.CmdAndCmdParam;
import com.c503.ca.cadv.module.ge.domain.CmdParam;
import com.c503.ca.cadv.module.ge.domain.vo.CmdParamVO;
import com.c503.ca.cadv.module.ge.repository.CmdParamRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 * 通用指令参数表 服务类
 * </p>
 *
 * @author jintch
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class CmdParamService extends DataVOService<CmdParamRepository, CmdParam, CmdParamVO> {


    public List<CmdParamVO> findAllByCmdId(String cmdId) {
        return findAllVO(createQuery().lambda().eq(CmdParam::getCmdId, cmdId));
    }

    public List<CmdAndCmdParam> findParamByObjCode(String objectCode) {
        return repository.findParamByObjCode(objectCode);
    }
}
