package com.c503.ca.cadv.module.ge.util;

import com.c503.ca.cadv.common.util.StringUtils;
import com.c503.ca.cadv.module.sys.domain.vo.DictVO;
import com.c503.ca.cadv.module.sys.util.DictUtils;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class CmdParamUtil {

    //有符号整型 0
    public static final String SIGNED = "dvc_cmd_param_type_signed";
    //无符号整型 1
    public static final String UNSIGNED = "dvc_cmd_param_type_unsigned";
    //标准浮点型 2
    public static final String STD_FLOAT = "dvc_cmd_param_type_std_float";
    //非标准浮点型 3
    public static final String USTD_FLOAT = "dvc_cmd_param_type_ustd_float";
    //无符号相对时间（秒） 4
    public static final String URLTTIME = "dvc_cmd_param_type_urlttime";
    //数据块 5
    public static final String DATABUF = "dvc_cmd_param_type_databuf";
    //有符号定点数 6
    public static final String FIX_POINT = "dvc_cmd_param_type_fix_point";
    //无符号定点数 7
    public static final String US_FIX_POINT = "dvc_cmd_param_type_us_fix_point";
    //有符号相对时（秒） 8
    public static final String RLTTIME = "dvc_cmd_param_type_rlttime";
    //非标准整型 9
    public static final String USTD_INT = "dvc_cmd_param_type_ustd_int";
    //浮点型绝对时 10
    public static final String FLOAT_ABSTIME = "dvc_cmd_param_type_float_abstime";
    //定点数相对时 11
    public static final String POINT_RLTTIME = "dvc_cmd_param_type_point_rlttime";
    //无符号绝对时 12
    public static final String US_FIX_ABSTIME = "dvc_cmd_param_type_us_fix_abstime";
    //指令块 13
    public static final String CMDBUF = "dvc_cmd_param_type_cmdbuf";
    //浮点型相对时 14
    public static final String FLOAT_RLTTIME = "dvc_cmd_param_type_float_rlttime";
    //TF浮点型时间 15
    public static final String TF_FLOAT_TIME = "dvc_cmd_param_type_tf_float_time";
    //GPS周秒时间 16
    public static final String GPS_WEEKTIME = "dvc_cmd_param_type_gps_weektime";
    //填充浮点型 17
    public static final String FILL_FOALT = "dvc_cmd_param_type_fill_foalt";
    //6字节相对时间 18
    public static final String BIT_RLTTIME = "dvc_cmd_param_type_bit_rlttime";
    //6字节绝对时间 19
    public static final String BIT_ABSTIME = "dvc_cmd_param_type_bit_abstime";
    //8字节相对时间 20
    public static final String BIT8_RLTTIME = "dvc_cmd_param_type_8bit_rlttime";


    public static String getType(String code) {
        if (StringUtils.isNotEmpty(code)) {
            List<DictVO> dictList = DictUtils.getDictList("dvc_cmd_param_type");
            for (DictVO dict : dictList) {
                if (code.equals(dict.getCode())) {
                    return dict.getVal();
                }
            }
        }
        return null;
    }

    public static String getTypeCode(String type) {
        if (StringUtils.isNotEmpty(type)) {
            List<DictVO> dictList = DictUtils.getDictList("dvc_cmd_param_type");
            for (DictVO dict : dictList) {
                if (type.equals(dict.getVal())) {
                    return dict.getCode();
                }
            }
        }
        return null;
    }
}
