package com.c503.ca.cadv.module.info.domain.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.google.common.collect.Maps;

import java.util.Map;


public enum CatalogType implements IEnum<Integer> {

    CMD_PLAN_FILE(5, "指令计划文件"),
    ORDER_SEQUENCE_FILE(6, "发令序列文件"),
    RSLT(8, "生成区"),
    TRNS(9, "发布区"),
    ORIN(10, "ORIN"),
    DC(11, "代传区"),
    PUBDC(12, "代传发布区"),
    BIN(13, "BIN"),
    DAT(14, "DAT"),
    ;

    private static final Map<Integer, CatalogType> enumMap = Maps.newHashMap();

    @JsonValue
    private final Integer value;

    private final String desc;

    CatalogType(Integer value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    static {
        for (CatalogType enumObj : values()) {
            enumMap.put(enumObj.getValue(), enumObj);
        }
    }

    public static CatalogType valueOf(int value) {
        CatalogType obj = enumMap.get(value);
        if (obj == null) {
            for (CatalogType enumObj : values()) {
                enumMap.put(enumObj.getValue(), enumObj);
            }
            obj = enumMap.get(value);
        }
        return obj;
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static CatalogType forValue(String value) {
        CatalogType result;
        try {
            result = valueOf(Integer.parseInt(value));
        } catch (NumberFormatException e) {
            result = forName(value);
        }
        return result;
    }

    public static CatalogType forName(String enumName) {
        for (CatalogType enumObj : values()) {
            if (enumObj.name().equals(enumName)) {
                return enumObj;
            }
        }
        return null;
    }

    @Override
    public String toString() {
        return this.getDesc();
    }

    @Override
    public Integer getValue() {
        //存入数据库内容
        return value;
    }
}
