package com.c503.ca.cadv.module.info.domain.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.google.common.collect.Maps;

import java.util.Map;

public enum TargetType implements IEnum<Integer> {

    MAN_AIRSHIP(1, "人船"),
    GOODS_AIRSHIP(2, "货船"),
    CORE_MODULE(3, "核心舱"),
    LAB_MODULE(4, "实验舱"),

    ;

    private static final Map<Integer, TargetType> enumMap = Maps.newHashMap();

    @JsonValue
    private final Integer value;

    private final String desc;

    TargetType(Integer value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    static {
        for (TargetType enumObj : values()) {
            enumMap.put(enumObj.getValue(), enumObj);
        }
    }

    public static TargetType valueOf(int value) {
        TargetType obj = enumMap.get(value);
        if (obj == null) {
            for (TargetType enumObj : values()) {
                enumMap.put(enumObj.getValue(), enumObj);
            }
            obj = enumMap.get(value);
        }
        return obj;
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static TargetType forValue(String value) {
        TargetType result;
        try {
            result = valueOf(Integer.parseInt(value));
        } catch (NumberFormatException e) {
            result = forName(value);
        }
        return result;
    }

    public static TargetType forName(String enumName) {
        for (TargetType enumObj : values()) {
            if (enumObj.name().equals(enumName)) {
                return enumObj;
            }
        }
        return null;
    }

    @Override
    public String toString() {
        return this.getDesc();
    }

    @Override
    public Integer getValue() {
        //存入数据库内容
        return value;
    }
}
