/**
* Copyright &copy; 2020-2021  c503-htphy All rights reserved.
*/
package com.c503.ca.cadv.module.info.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value="Target对象", description="")
public class TargetVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "目标代码")
    private String targetCode;

    @ApiModelProperty(value = "目标代号")
    private String targetNo;

    @ApiModelProperty(value = "所属任务ID", example = "1")
    private String taskId;

    @ApiModelProperty(value = "目标名称")
    private String targetName;

    @ApiModelProperty(value = "目标类型", example = "1")
    private Integer targetType;

    @ApiModelProperty(value = "注入数据名规则")
    private String injNameRule;

    @ApiModelProperty(value = "拥有DC")
    private Boolean hasDc;

    @ApiModelProperty(value = "图片")
    private String targetImg;

    @ApiModelProperty(value = "应用时间", example = "1")
    private Date applyTime;

    @ApiModelProperty(value = "描述")
    private String description;

    @ApiModelProperty(value = "RPGNC联合生数")
    private String rpgncUnionGen;

    @ApiModelProperty(value = "匹配规则")
    private String matchRules;

    @ApiModelProperty(value = "状态")
    private Integer status;

    @ApiModelProperty(value = "同步ID")
    private String syncId;

}
