package com.c503.ca.cadv.module.info.service;

import com.c503.ca.cadv.common.mvc.service.DataVOService;
import com.c503.ca.cadv.module.info.domain.Catalog;
import com.c503.ca.cadv.module.info.domain.enums.CatalogType;
import com.c503.ca.cadv.module.info.domain.vo.CatalogVO;
import com.c503.ca.cadv.module.info.repository.CatalogRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @Author hyx
 * @Date 2024/6/17 8:48
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class CatalogService extends DataVOService<CatalogRepository, Catalog, CatalogVO> {

    public Catalog findOneByCatalogType(CatalogType catalogType) {
        return findOne(createQuery().lambda().eq(Catalog::getCatalogType, catalogType));
    }
}
