package com.c503.ca.cadv.module.info.service;

import com.c503.ca.cadv.common.mvc.QueryDetail;
import com.c503.ca.cadv.common.mvc.domain.DataEntity;
import com.c503.ca.cadv.common.mvc.service.DataVOService;
import com.c503.ca.cadv.module.info.domain.Target;
import com.c503.ca.cadv.module.info.domain.vo.TargetVO;
import com.c503.ca.cadv.module.info.repository.TargetRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @Author hyx
 * @Date 2024/6/14 10:22
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class TargetService extends DataVOService<TargetRepository, Target, TargetVO> {
    public Target getByTargetCode(String targetCode) {
        QueryDetail<Target> query = createQuery();
        query.lambda().eq(Target::getTargetCode, targetCode).eq(DataEntity::getDeleted, 0);
        return findOne(query.getWrapper());
    }
}
