package com.c503.ca.cadv.module.info.util;

import com.c503.ca.cadv.common.util.spring.SpringContextHolder;
import com.c503.ca.cadv.module.info.service.CatalogService;
import com.c503.ca.cadv.module.info.service.TargetService;
import com.c503.ca.cadv.module.info.service.TargetZbService;
import com.c503.ca.cadv.module.info.service.TaskService;

/**
 * @Author hyx
 * @Date 2024/6/14 11:08
 */
public class InfoHelper {

    private static volatile TargetService targetService;

    public static TargetService getTargetService() {
        if (targetService == null) {
            synchronized (TargetService.class) {
                if (targetService == null) {
                    targetService = SpringContextHolder.getBean(TargetService.class);
                }
            }
        }
        return targetService;
    }

    private static volatile TargetZbService targetZbService;

    public static TargetZbService getTargetZbService() {
        if (targetZbService == null) {
            synchronized (TargetZbService.class) {
                if (targetZbService == null) {
                    targetZbService = SpringContextHolder.getBean(TargetZbService.class);
                }
            }
        }
        return targetZbService;
    }

    private static volatile TaskService taskService;

    public static TaskService getTaskService() {
        if (taskService == null) {
            synchronized (TaskService.class) {
                if (taskService == null) {
                    taskService = SpringContextHolder.getBean(TaskService.class);
                }
            }
        }
        return taskService;
    }

    private static volatile CatalogService catalogService;

    public static CatalogService getCatalogService() {
        if (catalogService == null) {
            synchronized (CatalogService.class) {
                if (catalogService == null) {
                    catalogService = SpringContextHolder.getBean(CatalogService.class);
                }
            }
        }
        return catalogService;
    }



}
