/**
 * Copyright &copy; 2020-2021  c503-phy All rights reserved.
 */
package com.c503.ca.cadv.module.log.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import lombok.*;
import lombok.experimental.Accessors;

/**
 * <p>
 * 用户操作日志
 * </p>
 *
 * @author steveshang
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("log_operate")
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class LogOperate extends IdAutoEntity<String> {

    private static final long serialVersionUID = 1L;

    /**
     * 用户名
     */
    @TableField("login_id")
    private String loginId;

    /**
     * 耗时
     */
    @TableField("time_consuming")
    private String timeConsuming;

    /**
     * 请求链接
     */
    @TableField("request_uri")
    private String requestUri;

    /**
     * 客户端用户标识
     */
    @TableField("user_agent")
    private String userAgent;

    /**
     * 请求方法
     */
    @TableField("request_method")
    private String requestMethod;

    /**
     * 请求来源
     */
    @TableField("remote_addr")
    private String remoteAddr;

    /**
     * 请求参数
     */
    @TableField("params_")
    private String params;

    @TableField("operate_")
    private String operate;

    @TableField("model_")
    private String model;
}
