package com.c503.ca.cadv.module.log.domain.enums;

import ch.qos.logback.classic.Level;
import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.google.common.collect.Maps;

import java.util.Map;

/**
 *
 */
public enum LogLevel implements IEnum<Integer> {

    /**
     * 错误
     */
    ERROR(Level.ERROR_INT, "ERROR"),
    /**
     * 警告
     */
    WARN(Level.WARN_INT, "WARN"),
    /**
     * 信息
     */
    INFO(Level.INFO_INT, "INFO"),
    DEBUG(Level.DEBUG_INT, "DEBUG"),
    TRACE(Level.TRACE_INT, "TRACE");

    private static final Map<Integer, LogLevel> enumMap = Maps.newHashMap();
    private final int levelInt;
    private final String levelStr;

    LogLevel(int i, String s) {
        levelInt = i;
        levelStr = s;
    }

    public static LogLevel valueOf(int value) {
        LogLevel level = enumMap.get(value);
        if (level == null) {
            for (LogLevel enumObj : values()) {
                enumMap.put(enumObj.getValue(), enumObj);
            }
            level = enumMap.get(value);
        }
        return level;
    }

    @JsonCreator   //jackson 映射枚举对象
    public static LogLevel forValue(Integer value) {
        return valueOf(value);
    }

    public int toInt() {
        return levelInt;
    }

    public String getLevelStr() {
        return levelStr;
    }

    @Override
    public String toString() {
        return this.getLevelStr();
    }

    @Override
    public Integer getValue() {
        //存入数据库内容
        return levelInt;
    }
}
