package com.c503.ca.cadv.module.log.domain.enums;

import com.baomidou.mybatisplus.annotation.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.google.common.collect.Maps;

import java.util.Map;

public enum QeLogErrType implements IEnum<Integer> {

    CLDG_ERR_OPENFILE(-1, "打开文件失败"),
    CLDG_ERR_READMASS(-100101, "读取注入结构初始化信息文件失败"),
    CLDG_ERR_MASSNULL(-100102, "注入结构初始化信息指针为NULL"),
    CLDG_ERR_READCMD(-100103, "读取指令初始化信息文件失败"),
    CLDG_ERR_CMDNULL(-100104, "指令初始化信息指针为NULL"),
    CLDG_ERR_CMDCVRT(-100105, "转换初始化指令的数据结构出错"),
    CLDG_ERR_CELLIDX(-100106, "数据单元cell的游标超限"),
    CLDG_ERR_FIELDIDX(-100107, "字段field的游标超限"),
    CLDG_ERR_FIELDDATLEN(-100108, "字段的二进制数据长度与字段要求长度不一致"),
    CLDG_ERR_CALCNULL(-100109, "计算字段长度为0"),
    CLDG_ERR_CALCFERR(-100110, "计算字段格式错误"),
    CLDG_ERR_FIELDDATTYPE(-100111, "字段数据类型错误"),
    CLDG_ERR_CALCBIT(-100112, "计算当量字段小于等于0"),
    CLDG_ERR_KWTCSHORT(-100113, "块尾字段最大长度小于被填充字段长度总和"),
    CLDG_ERR_AVAILLENCALC(-100114, "有效数据长度计算字段总和不是当量字段整数倍"),
    CLDG_ERR_READOBJINFO(-100115, "读取目标信息文件失败"),
    CLDG_ERR_CELLSZIENULL(-100116, "指令单元数目为空"),
    CLDG_ERR_GETINPUTDATA(-100117, "解析注入生成命令"),
    CLDG_ERR_SUBDIVFLAGNULL(-100118, "子层次标示为空"),
    CLDG_ERR_SUBCMDBINNULL(-100119, "子层指令二进制源码为空"),
    CLDG_ERR_READDELAYPLAN(-100120, "延时计划读取失败"),
    CLDG_ERR_FINDDELAYPLAN(-100121, "延时计划查注入数据失败"),
    CLDG_ERR_SETPLANVALUE(-100122, "延时计划查注入数据失败"),
    CLDG_ERR_INITVAL(-100123, "计算初值字段长度等于0"),

    CZF_ERR_KEYNOBIG(-10101, "识别字串的游标超长"),
    CZF_ERR_STRNULL(-10102, "字符串为NULL"),
    CZF_ERR_INPUTNULL(-10112, "输入参数为NULL"),
    CZF_ERR_MALLOC(-10113, "内存分配失败"),
    CZF_ERR_STRTOBIN(-10103, "字符串转换为二进制失败"),
    CZF_ERR_STRTOINT(-10104, "字符串转换为整形失败"),
    CZF_ERR_STRTOFLOAT(-10105, "字符串转换为浮点型失败"),
    CZF_ERR_COVENDIAN(-10106, "转换二进制字节序失败"),
    CZF_ERR_FLOATTOBIN(-10107, "浮点型转换为二进制失败"),
    CZF_ERR_INITOBIN(-10108, "整形转换为二进制失败"),
    CZF_ERR_VALOVERSIZE(-10109, "数值超限"),
    CZF_ERR_NOSTDINITOBIN(-10110, "非标准整形转换为二进制失败"),
    CZF_ERR_BINSETDATA(-10111, "bindata调用设置setdata错误"),
    CZF_ERR_CALCXOR(-10112, "计算纵向异或校验和错误"),
    CZF_ERR_BINTOINT(-10113, "二进制转换为整形失败"),
    CZF_ERR_CALCCRC(-10114, "计算纵向异或校验和错误"),
    CZF_ERR_STRTOUINT(-10115, "字符串转为无符号整形失败"),
    CZF_ERR_6BTIMETOBIN(-10116, "整形转换为二进制失败"),

    ;

    private static final Map<Integer, QeLogErrType> enumMap = Maps.newHashMap();

    @JsonValue
    private final Integer value;

    private final String desc;

    QeLogErrType(Integer value, String desc) {
        this.value = value;
        this.desc = desc;
    }

    public String getDesc() {
        return desc;
    }

    static {
        for (QeLogErrType enumObj : values()) {
            enumMap.put(enumObj.getValue(), enumObj);
        }
    }

    public static QeLogErrType valueOf(int value) {
        QeLogErrType obj = enumMap.get(value);
        if (obj == null) {
            for (QeLogErrType enumObj : values()) {
                enumMap.put(enumObj.getValue(), enumObj);
            }
            obj = enumMap.get(value);
        }
        return obj;
    }

    @JsonCreator(mode = JsonCreator.Mode.DELEGATING)
    public static QeLogErrType forValue(String value) {
        QeLogErrType result;
        try {
            result = valueOf(Integer.parseInt(value));
        } catch (NumberFormatException e) {
            result = forName(value);
        }
        return result;
    }

    public static QeLogErrType forName(String enumName) {
        for (QeLogErrType enumObj : values()) {
            if (enumObj.name().equals(enumName)) {
                return enumObj;
            }
        }
        return null;
    }

    @Override
    public String toString() {
        return this.getDesc();
    }

    @Override
    public Integer getValue() {
        //存入数据库内容
        return value;
    }
}

