/**
 * Copyright &copy; 2020-2021  c503-phy All rights reserved.
 */
package com.c503.ca.cadv.module.log.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 用户操作日志
 * </p>
 *
 * @author steveshang
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "LogOperate对象", description = "")
public class LogOperateVO extends DataEntityVO<String> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "用户名")
    private String loginId;

    @ApiModelProperty(value = "耗时", example = "1")
    private String timeConsuming;

    @ApiModelProperty(value = "请求链接")
    private String requestUri;

    @ApiModelProperty(value = "客户端用户标识")
    private String userAgent;

    @ApiModelProperty(value = "请求方法")
    private String requestMethod;

    @ApiModelProperty(value = "请求来源")
    private String remoteAddr;

    @ApiModelProperty(value = "请求参数")
    private String params;

    @ApiModelProperty(value = "操作")
    private String operate;

    @ApiModelProperty(value = "模块")
    private String model;
}
