package com.c503.ca.cadv.module.log.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.c503.ca.cadv.common.util.DateUtils;
import com.c503.ca.cadv.common.util.RequestUtils;
import com.c503.ca.cadv.common.util.SecurityUtils;
import com.c503.ca.cadv.common.util.StringUtils;
import com.c503.ca.cadv.module.log.domain.LogOperate;
import eu.bitwalker.useragentutils.UserAgent;

import javax.servlet.http.HttpServletRequest;

public class Logs {

    public static void saveOperate(HttpServletRequest request, String params, long beginTime, long endTime, MyLog myLog, JSONArray jsonArray) {
        final UserAgent userAgent = UserAgent.parseUserAgentString(request.getHeader("User-Agent"));
        final String remoteAddr = RequestUtils.getRemoteAddr(request);
        final String requestURI = request.getRequestURI();
        String requestMethod = myLog.type();
        if (!OperateType.DELETE.equals(requestMethod) && !OperateType.UPDATE.equals(requestMethod) && !OperateType.INSERT.equals(requestMethod) && jsonArray != null && StringUtils.isNotEmpty(myLog.type())) {
            String s = null;
            for (Object object : jsonArray) {
                if (object instanceof JSONObject) {
                    JSONObject jsonObject = (JSONObject) object;
                    Object o = jsonObject.get(myLog.type());
                    if (o != null) {
                        s = o.toString();
                    }
                }
            }
            if (StringUtils.isEmpty(s)) {
                requestMethod = OperateType.INSERT;
            } else {
                requestMethod = OperateType.UPDATE;
            }
        }

        LogOperate logOperate = LogOperate.builder()
                .loginId(SecurityUtils.getUsername())
                .requestMethod(requestMethod)
                .userAgent(userAgent.toString())
                .requestUri(requestURI)
                .remoteAddr(remoteAddr)
                .params(params)
                .timeConsuming(DateUtils.formatDateTime(endTime - beginTime))
                .operate(myLog.value())
                .model(myLog.model())
                .build();
        LogHelper.getOperateService().saveOrUpdate(logOperate);
    }
}
