package com.c503.ca.cadv.module.log.util;

import com.c503.ca.cadv.module.log.util.interceptor.OperateLogInterceptor;
import com.google.common.collect.Lists;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.AfterReturning;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

@Aspect
@Component
public class SysLogAspect {



    @Pointcut("@annotation(MyLog)")
    public void logPointCut(){
    }


    @AfterReturning("logPointCut()")
    public void saveSysLog(JoinPoint joinPoint) {
        Object[] args = joinPoint.getArgs();
        List<Object> logArgs = Lists.newArrayList();
        for (Object o : args) {
            if (!(o instanceof HttpServletRequest) && !(o instanceof HttpServletResponse)) {
                logArgs.add(o);
            }
        }

        OperateLogInterceptor.PARAMS.set(logArgs);
    }

}
