package com.c503.ca.cadv.module.plan.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import com.c503.ca.cadv.common.util.StringUtils;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 9:47
 */
@Data
@Accessors(chain = true)
@TableName("inj_cmd_inst")
public class CmdInst extends IdAutoEntity<String> implements Comparable<CmdInst>{

    @TableField("file_data_id")
    private String fileDataId;

    @TableField("cmd_param_inst_id")
    private String cmdParamInstId;

    @TableField("object_code")
    private String objectCode;

    @TableField("plan_manual_mark")
    private String planManualMark;

    @TableField("package_no")
    private String packageNo;

    @TableField("cmd_code")
    private String cmdCode;

    @TableField("cmd_name")
    private String cmdName;

    @TableField("field_")
    private String field;

    public String getField() {
        if (this.field == null) {
            return "NULL";
        }
        return this.field;
    }

    @TableField("sign_")
    private String sign;

    @TableField("all_param_sign")
    private String allParamSign;

    @TableField("package_sign")
    private String packageSign;

    @TableField("sort_")
    private Integer sort;

    @TableField(exist = false)
    private List<CmdParamInst> cmdParamInstList;

    public String generateText() {
        int length = 20;
        String enter = "\n";
        String space = " ";
        StringBuilder text = new StringBuilder();
        text.append(StringUtils.getFixedLengthStr(getPlanManualMark(), length));
        text.append(getCmdCode() + space);
        text.append(getSign() + space);
        text.append(getPackageSign() + space);
        text.append(getPackageNo() + space);
        text.append(getField() + space);
        text.append(getAllParamSign() + space);

        List<CmdParamInst> cmdParamInstList = getCmdParamInstList();
        if (cmdParamInstList != null) {
            for (CmdParamInst cmdParamInst : cmdParamInstList) {
                text.append(cmdParamInst.generateText());
            }
        }
        text.append(enter);
        return text.toString();
    }

    @Override
    public int compareTo(CmdInst cmdInst) {
        return this.sort - cmdInst.sort > 0 ? 1 : -1;
    }

    public String formatValueOfS() {
        String and = "&";
        StringBuilder text = new StringBuilder();
        text.append(getPlanManualMark()).append(and).append(and);
        text.append(getCmdCode()).append(and);
        text.append(getSign()).append(and);
        text.append(getPackageSign()).append(and);
        text.append(getPackageNo()).append(and);
        text.append(getField()).append(and);
        text.append(getAllParamSign()).append(and);

        List<CmdParamInst> cmdParamInstList = getCmdParamInstList();
        for (CmdParamInst cmdParamInst : cmdParamInstList) {
            text.append(cmdParamInst.formatValueOfS());
        }
        return text.toString();
    }
}
