package com.c503.ca.cadv.module.plan.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import com.c503.ca.cadv.module.ge.domain.enums.ParamSignType;
import lombok.Data;
import lombok.experimental.Accessors;
import org.apache.ibatis.type.BlobTypeHandler;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 9:55
 */
@Data
@Accessors(chain = true)
@TableName("inj_cmd_param_inst")
public class CmdParamInst extends IdAutoEntity<String> implements Comparable<CmdParamInst>{

    @TableField("cmd_inst_id")
    private String cmdInstId;

    @TableField("object_code")
    private String objectCode;

    @TableField("code_")
    private String code;

    @TableField("data_no")
    private Integer dataNo;

    @TableField("single_param_sign")
    private ParamSignType singleParamSign;

    @TableField("value_")
    private String value;

    @TableField("file_value")
    private String fileValue;

    @TableField("base_time")
    private String baseTime;

    @TableField("explain_")
    private String explain;

    @TableField("type_")
    private String type;

    @TableField("len_")
    private Integer len;

    @TableField("dimen_")
    private String dimen;

    @TableField("dimen_sign")
    private String dimenSign;

    @TableField("para_path")
    private String paraPath;

    @TableField("value_range")
    private String valueRange;

    @TableField("fix_")
    private String fix;

    @TableField(value = "file_", typeHandler = BlobTypeHandler.class, select = false)
    private byte[] file;

    @TableField(exist = false)
    private List<CmdInst> cmdInstList;

    public static String formatValueOfS(List<CmdInst> cmdInstList) {
        if (cmdInstList != null) {
            StringBuilder text = new StringBuilder();
            cmdInstList.sort(CmdInst::compareTo);
            for (int i = 0; i < cmdInstList.size(); i++) {
                text.append(cmdInstList.get(i).formatValueOfS());
                if (i != (cmdInstList.size() - 1)) {
                    text.append(";");
                }
            }
            return text.toString();
        }
        return null;
    }

    @Override
    public int compareTo(CmdParamInst cmdParamInst) {
        return this.dataNo - cmdParamInst.dataNo > 0 ? 1 : -1;
    }

    public String generateText() {
        String space = " ";
        StringBuilder text = new StringBuilder();
        text.append(getDataNo()).append(space).append(getSingleParamSign().getValue()).append(space).append(formatValue()).append(space);
        return text.toString();
    }

    public String formatValue() {
        if (getSingleParamSign().equals(ParamSignType.D) || null == this.value) {
            return " ";
        }
        return this.value;
    }

    public String formatValueOfS() {
        String and = "&";
        StringBuilder text = new StringBuilder();
        text.append(getDataNo()).append(and).append(getSingleParamSign().getValue()).append(and).append(formatValueInS()).append(and);
        return text.toString();
    }

    public String formatValueInS() {
        if (getSingleParamSign().equals(ParamSignType.D)) {
            return "";
        }
        return this.value;
    }

}
