package com.c503.ca.cadv.module.plan.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/19 8:41
 */
@Data
@Accessors(chain = true)
@TableName("inj_config_file")
public class ConfigFile extends IdAutoEntity<String> {

    public static final String SUFFIX = ".cfg";

    @TableField("file_name")
    private String fileName;

    @TableField("object_code")
    private String objectCode;

    @TableField("relation_id")
    public String relationId;

    @TableField(exist = false)
    private List<FileData> fileDataList;

    public String generateText() {
        String enter = "\n";
        StringBuilder text = new StringBuilder();
        List<FileData> fileDataList = getFileDataList();
        if (fileDataList != null) {
            for (FileData fileData : fileDataList) {
                text.append(fileData.generateText());
                text.append("********************************" + enter);
            }
        }
        return text.toString();
    }
}
