package com.c503.ca.cadv.module.plan.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.IdAutoEntity;
import com.c503.ca.cadv.common.util.DateUtils;
import com.c503.ca.cadv.common.util.StringUtils;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 8:53
 */
@Data
@Accessors(chain = true)
@TableName("inj_file_data")
public class FileData extends IdAutoEntity<String> {

    @TableField("config_file_id")
    private String configFileId;

    @TableField("object_code")
    private String objectCode;

    @TableField("file_")
    private String file;

    @TableField("order_")
    private String  order;

    @TableField("block_no_type")
    private String blockNoType;

    @TableField("block_no_val")
    private String blockNoVal;

    @TableField("block_no_in_type")
    private String blockNoInType;

    @TableField("block_no_in_val")
    private String blockNoInVal;

    @TableField("begin_time")
    private String beginTime;

    @TableField("end_time")
    private String endTime;

    @TableField("ckb_time")
    private String ckbTime;

    @TableField("cke_time")
    private String ckeTime;

    @TableField("ckzr_type")
    private String ckzrType;

    @TableField("ckzr_way")
    private String ckzrWay;

    @TableField("gncb_time")
    private String gncbTime;

    @TableField("gnce_time")
    private String gnceTime;

    @TableField("out_type")
    private String outType;

    @TableField("comment_")
    private String comment;

    @TableField("input_status")
    private String inputStatus;

    @TableField("zj_begin_time")
    private String zjBeginTime;

    @TableField("zj_end_time")
    private String zjEndTime;

    @TableField("cz_code")
    private String czCode;

    @TableField("lq_begin_time")
    private String lqBeginTime;

    @TableField("lq_end_time")
    private String lqEndTime;

    @TableField("zr_way_lq")
    private String zrWayLq;

    @TableField("gzcx_begin_time")
    private String gzcxBeginTime;

    @TableField("gzcx_end_time")
    private String gzcxEndTime;

    @TableField(exist = false)
    private List<CmdInst> cmdInstList;

    public String getBlockNo() {
        return getBlockNoType() + " " + getBlockNoVal();
    }

    public String getBlockNoIn() {
        return getBlockNoInType() + " " + getBlockNoInVal();
    }

    public String generateText() {
        int length = 20;
        String enter = "\n";
        StringBuilder text = new StringBuilder();
        text.append("#" + DateUtils.formatDateToCN(getCreatedDate()) + enter);
        text.append(StringUtils.getFixedLengthStr("FILE", length) + getFile() + enter);
        text.append(StringUtils.getFixedLengthStr("Order", length) + getOrder() + enter);
        text.append(StringUtils.getFixedLengthStr("BlockNO", length) + getBlockNo() + enter);
        text.append(StringUtils.getFixedLengthStr("BlockNOIn", length) + getBlockNoIn() + enter);
        text.append(StringUtils.getFixedLengthStr("BeginTime", length) + (StringUtils.isEmpty(getBeginTime()) ? "NULL" : getBeginTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("EndTime", length) + (StringUtils.isEmpty(getEndTime()) ? "NULL" : getEndTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("CKBTime", length) + (StringUtils.isEmpty(getCkbTime()) ? "NULL" : getCkbTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("CKETime", length) + (StringUtils.isEmpty(getCkeTime()) ? "NULL" : getCkeTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("CKZrType", length) + (StringUtils.isEmpty(getCkzrType()) ? "NULL" : getCkzrType()) + enter);
        text.append(StringUtils.getFixedLengthStr("CKZrWay", length) + (StringUtils.isEmpty(getCkzrWay()) ? "NULL" : getCkzrWay()) + enter);

        // 新增的字段
        text.append(StringUtils.getFixedLengthStr("zjBeginTime", length) + (StringUtils.isEmpty(getZjBeginTime()) ? "NULL" : getZjBeginTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("zjEndTime", length) + (StringUtils.isEmpty(getZjEndTime()) ? "NULL" : getZjEndTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("gzcxBeginTime", length) + (StringUtils.isEmpty(getGzcxBeginTime()) ? "NULL" : getGzcxBeginTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("gzcxEndTime", length) + (StringUtils.isEmpty(getGzcxEndTime()) ? "NULL" : getGzcxEndTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("czCode", length) + (StringUtils.isEmpty(getCzCode()) ? "NULL" : getCzCode()) + enter);
        text.append(StringUtils.getFixedLengthStr("lqBeginTime", length) + (StringUtils.isEmpty(getLqBeginTime()) ? "NULL" : getLqBeginTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("lqEndTime", length) + (StringUtils.isEmpty(getLqEndTime()) ? "NULL" : getLqEndTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("LQZrWay ", length) + (StringUtils.isEmpty(getZrWayLq()) ? "NULL" : getZrWayLq()) + enter);

        text.append(StringUtils.getFixedLengthStr("GNCBTime", length) + (StringUtils.isEmpty(getGncbTime()) ? "NULL" : getGncbTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("GNCETime", length) + (StringUtils.isEmpty(getGnceTime()) ? "NULL" : getGnceTime()) + enter);
        text.append(StringUtils.getFixedLengthStr("OutType", length) + getOutType() + enter);

        List<CmdInst> cmdInstList = getCmdInstList();
        if (cmdInstList != null) {
            for (CmdInst cmdInst : cmdInstList) {
                text.append(cmdInst.generateText());
            }
        }
        return text.toString();
    }
}
