package com.c503.ca.cadv.module.plan.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 13:54
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value="CmdInst对象", description="注入文件数据指令实例表")
public class CmdInstVO extends DataEntityVO<String> {

    @ApiModelProperty(value = "所属文件数据ID", example = "1")
    private String fileDataId;

    @ApiModelProperty("所属指令参数实例ID")
    private String cmdParamInstId;

    @ApiModelProperty(value = "计划手动标注")
    private String planManualMark;

    @ApiModelProperty(value = "包序号")
    private String packageNo;

    @ApiModelProperty(value = "指令代号")
    private String cmdCode;

    @ApiModelProperty(value = "指令名称")
    private String cmdName;

    @ApiModelProperty(value = "指定方式字")
    private String field;

    @ApiModelProperty(value = "同帧标识")
    private String sign;

    @ApiModelProperty(value = "全部参数标识")
    private String allParamSign;

    @ApiModelProperty(value = "同包标识")
    private String packageSign;

    @ApiModelProperty(value = "识别字")
    private String keyStr;

    @ApiModelProperty(value = "指令排序", example = "1")
    private Integer sort;

    @ApiModelProperty(value = "指令参数实例集合")
    private List<CmdParamInstVO> cmdParamInstList;

    @ApiModelProperty(value = "目标码")
    private String objectCode;

    private Integer isDc;
}
