package com.c503.ca.cadv.module.plan.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import com.c503.ca.cadv.module.ge.domain.enums.ParamSignType;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 13:55
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "CmdParamInst对象", description = "注入文件数据指令参数实例表")
public class CmdParamInstVO extends DataEntityVO<String> {

    @ApiModelProperty(value = "所属指令实例ID", example = "1")
    private String cmdInstId;

    @ApiModelProperty(value = "参数代号")
    private String code;

    @ApiModelProperty(value = "参数序号", example = "1")
    private Integer dataNo;

    @ApiModelProperty(value = "单个参数标识")
    private ParamSignType singleParamSign;

    @ApiModelProperty(value = "参数值")
    private String value;

    @ApiModelProperty(value = "基准时")
    private String baseTime;

    @ApiModelProperty(value = "意义")
    private String explain;

    @ApiModelProperty(value = "参数类型")
    private String type;

    @ApiModelProperty(value = "长度", example = "1")
    private Integer len;

    @ApiModelProperty(value = "量纲")
    private String dimen;

    @ApiModelProperty(value = "量纲标识")
    private String dimenSign;

    @ApiModelProperty(value = "取值路径")
    private String paraPath;

    @ApiModelProperty(value = "文件值")
    private String fileValue;

    @ApiModelProperty(value = "文件")
    @JsonIgnore
    private byte[] file;

    @ApiModelProperty(value = "取值文件本地路径")
    @JsonIgnore
    private String paraFileLocalPath;

    @ApiModelProperty(value = "文件路径")
    private String filePath;

    @ApiModelProperty(value = "取值范围")
    private String valueRange;

    @ApiModelProperty(value = "标称值")
    private String fix;

    @ApiModelProperty(value = "当单个参数标识为S时的值")
    private List<CmdInstVO> cmdInstList;

    private String objectCode;

    private String cmdCode;

    private String paramValue;

    private String compValue;

    private Integer compResult;
}
