package com.c503.ca.cadv.module.plan.domain.vo;

import com.c503.ca.cadv.common.mvc.domain.vo.DataEntityVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * @author huyouxiang
 * @date 2023/12/13 13:51
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@ApiModel(value = "FileData对象", description = "注入数据")
public class FileDataVO extends DataEntityVO<String> {

    @ApiModelProperty(value = "注入配置ID", example = "1")
    private String configFileId;

    @ApiModelProperty(value = "文件名")
    private String file;

    @ApiModelProperty(value = "组帧顺序")
    private String order;

    @ApiModelProperty(value = "块号控制类型", example = "Only")
    private String blockNoType;

    @ApiModelProperty(value = "块号控制值", example = "0")
    private String blockNoVal;

    @ApiModelProperty(value = "内部块号类型", example = "Only")
    private String blockNoInType;

    @ApiModelProperty(value = "内部块号值", example = "0")
    private String blockNoInVal;

    @ApiModelProperty(value = "延时指令开始时间")
    private String beginTime;

    @ApiModelProperty(value = "延时指令结束时间")
    private String endTime;

    @ApiModelProperty(value = "程控指令开始时间")
    private String ckbTime;

    @ApiModelProperty(value = "程控指令结束时间")
    private String ckeTime;

    @ApiModelProperty(value = "程控指令注入类型")
    private String ckzrType;

    @ApiModelProperty(value = "程控指令注入模式")
    private String ckzrWay;

    @ApiModelProperty(value = "GNC指令开始时间")
    private String gncbTime;

    @ApiModelProperty(value = "直传/串行代传/高通代传")
    private String outType;

    @ApiModelProperty(value = "注释")
    private String comment;

    /*********** 后续补充字段 **************/
    /**
     * 选中的互斥的状态，页面上的字段（程控指令输入，中继包输入，落区输入，工作程序包输入相互互斥）
     */
    @ApiModelProperty(value = "选中的互斥的状态")
    private String inputStatus;

    /**
     * 中继包开始时间
     */
    @ApiModelProperty(value = "中继包开始时间")
    private String zjBeginTime;

    @ApiModelProperty(value = "GNC指令结束时间")
    private String gnceTime;

    /**
     * 测站代码
     */
    @ApiModelProperty(value = "测站代码")
    private String czCode;
    /**
     * 中继包结束时间
     */
    @ApiModelProperty(value = "中继包结束时间")
    private String zjEndTime;
    /**
     * 落区结束时间
     */
    @ApiModelProperty(value = "落区结束时间")
    private String lqEndTime;
    /**
     * 落区注入模式（仅增不删，先删后增，边删边增）
     */
    @ApiModelProperty(value = "落区注入模式")
    private String zrWayLq;

    /**
     * 工作程序包开始时间
     */
    @ApiModelProperty(value = "工作程序包开始时间")
    private String gzcxBeginTime;
    /**
     * 工作程序包结束时间
     */
    @ApiModelProperty(value = "工作程序包结束时间")
    private String gzcxEndTime;
    /**
     * 落区开始时间
     */
    @ApiModelProperty(value = "落区开始时间")
    private String lqBeginTime;

    @ApiModelProperty(value = "目标码")
    private String objectCode;

    public void setOrder(String order) {
        if ("NULL".equalsIgnoreCase(order)) {
            this.order = null;
        } else {
            this.order = order;
        }
    }

    public void setBlockNoType(String blockNoType) {
        if ("NULL".equalsIgnoreCase(blockNoType)) {
            this.blockNoType = null;
        } else {
            this.blockNoType = blockNoType;
        }
    }

    public void setBlockNoVal(String blockNoVal) {
        if ("NULL".equalsIgnoreCase(blockNoVal)) {
            this.blockNoVal = null;
        } else {
            this.blockNoVal = blockNoVal;
        }
    }

    public void setBlockNoInType(String blockNoInType) {
        if ("NULL".equalsIgnoreCase(blockNoInType)) {
            this.blockNoInType = null;
        } else {
            this.blockNoInType = blockNoInType;
        }
    }

    public void setBlockNoInVal(String blockNoInVal) {
        if ("NULL".equalsIgnoreCase(blockNoInVal)) {
            this.blockNoInVal = null;
        } else {
            this.blockNoInVal = blockNoInVal;
        }
    }

    public void setCkzrType(String ckzrType) {
        if ("NULL".equalsIgnoreCase(ckzrType)) {
            this.ckzrType = null;
        } else {
            this.ckzrType = ckzrType;
        }
    }

    public void setCkzrWay(String ckzrWay) {
        if ("NULL".equalsIgnoreCase(ckzrWay)) {
            this.ckzrWay = null;
        } else {
            this.ckzrWay = ckzrWay;
        }
    }

    public void setOutType(String outType) {
        if ("NULL".equalsIgnoreCase(outType)) {
            this.outType = null;
        } else {
            this.outType = outType;
        }
    }

    public void setInputStatus(String inputStatus) {
        if ("NULL".equalsIgnoreCase(inputStatus)) {
            this.inputStatus = null;
        } else {
            this.inputStatus = inputStatus;
        }
    }

    public void setCzCode(String czCode) {
        if ("NULL".equalsIgnoreCase(czCode)) {
            this.czCode = null;
        } else {
            this.czCode = czCode;
        }
    }

    public void setZrWayLq(String zrWayLq) {
        if ("NULL".equalsIgnoreCase(zrWayLq)) {
            this.zrWayLq = null;
        } else {
            this.zrWayLq = zrWayLq;
        }
    }

    public void setBeginTime(String beginTime) {
        if ("NULL".equalsIgnoreCase(beginTime)) {
            this.beginTime = null;
        } else {
            this.beginTime = beginTime;
        }
    }

    public void setCkbTime(String ckbTime) {
        if ("NULL".equalsIgnoreCase(ckbTime)) {
            this.ckbTime = null;
        } else {
            this.ckbTime = ckbTime;
        }
    }

    public void setCkeTime(String ckeTime) {
        if ("NULL".equalsIgnoreCase(ckeTime)) {
            this.ckeTime = null;
        } else {
            this.ckeTime = ckeTime;
        }
    }

    public void setGncbTime(String gncbTime) {
        if ("NULL".equalsIgnoreCase(gncbTime)) {
            this.gncbTime = null;
        } else {
            this.gncbTime = gncbTime;
        }
    }

    public void setGnceTime(String gnceTime) {
        if ("NULL".equalsIgnoreCase(gnceTime)) {
            this.gnceTime = null;
        } else {
            this.gnceTime = gnceTime;
        }
    }

    @ApiModelProperty(value = "指令实例集合")
    private List<CmdInstVO> cmdInstList;

    public void setZjBeginTime(String zjBeginTime) {
        if ("NULL".equalsIgnoreCase(zjBeginTime)) {
            this.zjBeginTime = null;
        } else {
            this.zjBeginTime = zjBeginTime;
        }
    }

    public void setZjEndTime(String zjEndTime) {
        if ("NULL".equalsIgnoreCase(zjEndTime)) {
            this.zjEndTime = null;
        } else {
            this.zjEndTime = zjEndTime;
        }
    }

    public void setLqBeginTime(String lqBeginTime) {
        if ("NULL".equalsIgnoreCase(lqBeginTime)) {
            this.lqBeginTime = null;
        } else {
            this.lqBeginTime = lqBeginTime;
        }
    }

    public void setLqEndTime(String lqEndTime) {
        if ("NULL".equalsIgnoreCase(lqEndTime)) {
            this.lqEndTime = null;
        } else {
            this.lqEndTime = lqEndTime;
        }
    }

    public void setGzcxBeginTime(String gzcxBeginTime) {
        if ("NULL".equalsIgnoreCase(gzcxBeginTime)) {
            this.gzcxBeginTime = null;
        } else {
            this.gzcxBeginTime = gzcxBeginTime;
        }
    }

    public void setGzcxEndTime(String gzcxEndTime) {
        if ("NULL".equalsIgnoreCase(gzcxEndTime)) {
            this.gzcxEndTime = null;
        } else {
            this.gzcxEndTime = gzcxEndTime;
        }
    }
}
