package com.c503.ca.cadv.module.plan.util;

import com.c503.ca.cadv.module.ge.domain.enums.ParamSignType;
import com.c503.ca.cadv.module.ge.domain.vo.CmdParamVO;
import com.c503.ca.cadv.module.ge.domain.vo.CmdVO;
import com.c503.ca.cadv.module.plan.domain.vo.CmdInstVO;
import com.c503.ca.cadv.module.plan.domain.vo.CmdParamInstVO;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.compress.utils.Lists;

import java.util.List;

public class CmdConvertUtils {

    public static CmdInstVO convertCmdVoToCmdInstVo(CmdVO cmdVO){
        CmdInstVO cmdInstVO = new CmdInstVO();
        //设置指令
        cmdInstVO.setCmdCode(cmdVO.getCmdCode());
        cmdInstVO.setCmdName(cmdVO.getCmdName());
        cmdInstVO.setKeyStr(cmdVO.getKeyStr());
        cmdInstVO.setObjectCode(cmdVO.getObjectCode());
        List<CmdParamVO> cmdParamList = cmdVO.getCmdParamVOList();
        if(CollectionUtils.isNotEmpty(cmdParamList)){
            List<CmdParamInstVO> cmdParamInstVOList = Lists.newArrayList();
            for(CmdParamVO cmdParamVO: cmdParamList){
                CmdParamInstVO cmdParamInstVO = new CmdParamInstVO();
                cmdParamInstVO.setCode(cmdParamVO.getCode());
                cmdParamInstVO.setSingleParamSign(ParamSignType.D);
                cmdParamInstVO.setExplain(cmdParamVO.getExplain());
                cmdParamInstVO.setType(cmdParamVO.getType() == null ? null : cmdParamVO.getType().toString());
                cmdParamInstVO.setLen(cmdParamVO.getLen());
                cmdParamInstVO.setDimen(cmdParamVO.getDimen());
                cmdParamInstVO.setValueRange(cmdParamVO.getValueRange());
                cmdParamInstVO.setParaPath(cmdParamVO.getParaPath());
                cmdParamInstVO.setFix(cmdParamVO.getFix());
                cmdParamInstVOList.add(cmdParamInstVO);
            }
            cmdInstVO.setCmdParamInstList(cmdParamInstVOList);
        }

        return cmdInstVO;
    }
}
