package com.c503.ca.cadv.module.plan.web;

import com.c503.ca.cadv.common.rest.base.DataVOResource;
import com.c503.ca.cadv.common.util.JacksonUtils;
import com.c503.ca.cadv.common.util.domain.CustomMessage;
import com.c503.ca.cadv.common.util.domain.PageModel;
import com.c503.ca.cadv.common.util.domain.ResultBuilder;
import com.c503.ca.cadv.module.plan.domain.vo.CmdParamInstVO;
import com.c503.ca.cadv.module.plan.service.CmdParamInstService;
import com.fasterxml.jackson.databind.JsonNode;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author huyouxiang
 * @date 2023/12/13 14:06
 */
@RestController
@RequestMapping("/plan/cmd-param-inst")
@Api(tags = "cmd-param-inst")
public class CmdParamInstResource extends DataVOResource<CmdParamInstService, CmdParamInstVO> {

    public CmdParamInstResource(CmdParamInstService service) {
        super(service);
    }

    @GetMapping(value = "/")
    @ApiOperation(value = "获取注入配置文件表列表", notes = "根据分页参数，获取分页列表")
    public ResponseEntity<CustomMessage<JsonNode>> getPage(PageModel pm) {
        service.findVOPage(pm);
        JsonNode rs = JacksonUtils.toJsonNodeWithDefaultMapper(pm);
        return ResultBuilder.buildObject(rs);
    }
}
