package com.c503.ca.cadv.module.sys.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.c503.ca.cadv.common.mvc.domain.BaseEntity;
import com.c503.ca.cadv.common.mvc.domain.TreeAutoIdEntity;
import com.c503.ca.cadv.common.util.annotation.DictType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlTransient;

/**
 * 字典实体
 *
 * @author liaow
 */
@TableName("sys_dict")
@Data
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
public class Dict extends TreeAutoIdEntity<String> {

    /**
     * 叶子节点
     */
    public static final String FLAG_LEAF = "0";
    /**
     * 非叶子节点
     */
    public static final String FLAG_UNLEAF = "1";

    private static final long serialVersionUID = 1L;
    @XmlTransient
    @TableField(BaseEntity.F_SQL_DESCRIPTION)
    protected String description;

    /*** 编码 */
    @TableField("code_")
    private String code;

    /*** 字典值 */
    @TableField("val_")
    private String val;

    /*** 资源文件key */
    @TableField("show_name")
    private String showName;

    /*** key */
    @TableField("key_")
    private String key;

    @NotNull
    @TableField("is_show")
    @DictType(name = "sys_yes_no")
    private Integer isShow = 1;

    @TableField("parent_code")
    private String parentCode;

    @TableField("color_")
    private String color;

    @XmlAttribute
    public String getVal() {
        return val;
    }

    public void setVal(String val) {
        this.val = val;
    }

    public Integer getIsShow() {
        return isShow;
    }

    public void setIsShow(Integer isShow) {
        this.isShow = isShow;
    }

    @Override
    @XmlAttribute
    public String getName() {
        return super.getName();
    }

    @Override
    public void setName(String name) {
        super.setName(name);
    }

}
