package serv.jzfm;

import java.util.HashMap;
import java.util.Map;
import java.util.Queue;

public class JZFMRe {

    /**
     * 电文发送示例
     * @throws InterruptedException
     */
    public static void sendMsg(JZFM_MsgInfo msghead) throws InterruptedException {
        int            ret;
        int            i=0;

        JZFM jzfm = new JZFM();
        /* 电文服务初始化 */
        ret = jzfm.jzfm_init();
        if(ret < 0)
        {
            //zfm_perror(ret, "ms_init");
            System.out.println("jzfm_init, ret:" + ret);
            return;
        }

        /* 发送电文 */
        ret = jzfm.jzfm_send(msghead);
        if(ret < 0)
        {
            //zfm_perror(ret, "ms_send");
            System.out.println("jzfm_send, ret:" + ret);
            return ;
        }
        Thread.sleep(1000);
        System.out.printf("%d\tlen=%d\n", i++, msghead.getsMsgCont().length);
    }

    /**
     * 电文接收示例
     */
    public static Map<String,JZFM_MsgInfo> recvMsg(JZFM_SubInfo[] subinfos)  {
        Map<String,JZFM_MsgInfo> result = new HashMap<String,JZFM_MsgInfo>();
        JZFM jzfm = new JZFM();
        /* 电文服务初始化 */
        int ret = jzfm.jzfm_init();
        if(ret < 0){
            System.out.println("jzfm_init, ret:" + ret);
            return result;
        }

        /* 电文订阅 */
        int qid = jzfm.jzfm_open(subinfos.length, subinfos, 1024*64);
        if(qid < 0){
            System.out.println("jzfm_open, ret:" + ret);
            return result;
        }


        /* 阻赛式电文监听 */
        final int size = subinfos.length;
        //size != result.size()
        while (size != result.size()) {
            JZFM_MsgInfo stMsgHead = new JZFM_MsgInfo();
            ret = jzfm.jzfm_recvw(qid, stMsgHead);
            if(ret < 0){
                System.out.println("jzfm_recvw, ret:" + ret + ";电文接收失败");
                continue;
            } else {
                result.put(String.valueOf(stMsgHead.getUiMsgType()), stMsgHead );
            }
        }
        return result;
    }

    /**
     * 电文接收示例
     */
    public static void recvMsgQueue(JZFM_SubInfo[] subinfos, Queue<JZFM_MsgInfo> queueData){
        JZFM jzfm = new JZFM();
        /* 电文服务初始化 */
        int ret = jzfm.jzfm_init();
        if(ret < 0){
            System.out.println("jzfm_init, ret:" + ret);
            return;
        }

        /* 电文订阅 */
        int qid = jzfm.jzfm_open(subinfos.length, subinfos, 1024*64);
        if(qid < 0){
            System.out.println("jzfm_open, ret:" + ret);
            return;
        }

        /* 阻赛式电文监听 */
        while (true){
            JZFM_MsgInfo stMsgHead = new JZFM_MsgInfo();
            ret = jzfm.jzfm_recvw(qid, stMsgHead);
            if(ret < 0){
                System.out.println("jzfm_recvw, ret:" + ret + ";电文接收失败");
                continue;
            }
            queueData.offer(stMsgHead);
//            System.out.println("jzfm_recvw, queue:" + queueData.size());
        }
    }

}
